package ActivatePackage
{
	function SimObject::onCameraEnterOrbit(%obj, %camera) {}
  function SimObject::onCameraLeaveOrbit(%obj, %camera) {}	
	function serverCmdDroptool(%this,%slot)
	{
		%player = %this.player;
		if (!isObject(%player))
			return;
		%start = %player.getEyePoint();
		%path = vectorScale(%player.getEyeVector(), 6);
		%end = vectorAdd(%start, %path);

		%mask = (
		  $TypeMasks::ItemObjectType |
		  $TypeMasks::PlayerObjectType |
		  $TypeMasks::VehicleObjectType |
		  $TypeMasks::FxBrickObjectType
		);
		%ray = containerRayCast(%start, %end, %mask, %player);
		if(!%ray)
			return parent::serverCmdDroptool(%this,%slot);
		%col = getWord(%ray,0);
		if(isObject(%col) && (%col.getType() & $TypeMasks::FxBrickObjectType))
		{
			if(%col.dataBlock.isFurnace)
			{
				%db = %player.tool[%slot];
				if(%db == 0 || %db $= "")
					return;
				%player.tool[%slot] = 0;
				%player.weaponCount--;
				messageClient(%this, 'MsgItemPickup', '', %slot, 0);			
				%player.unMountImage(0);
				%salv = 2;
				if(%db.className $= "Weapon")
					%salv = 4;
				if(%db.recycleValue > 0)
					%salv = %db.recycleValue;
				%player.modSalvage(%salv);
				%player.toolMag[%slot] = "";
				serverPlay3d(recycleSound,%col.getPosition());
			}
			if(%col.dataBlock.crateSize > 0)
			{
				%inv = %col.inventory;
				%db = %player.tool[%slot];
				if(getOpenSlot(%col.inventory,%col.dataBlock.crateSize) >= 0)
				{
					%crateSlot = getOpenSlot(%col.inventory,%col.dataBlock.crateSize);
					%col.inventory = setWord(%col.inventory,%crateSlot,%db.getName());
					%player.tool[%slot] = 0;
					%player.weaponCount--;
					messageClient(%this, 'MsgItemPickup', '', %slot, 0);			
					%player.unMountImage(0);	
					%col.ammo[%crateSlot] = %player.toolMag[%slot];
					%player.toolMag[%slot] = "";
					%player.client.showCrateInv(%col);
				}
				
			}
		}
		parent::serverCmdDroptool(%this,%slot);
	}
	function ItemData::onPickup(%this, %obj, %user, %amount)
	{
		%l = %obj.isLoot;
		%trash = %obj.dataBlock.isTrash;
		%res = Parent::onPickup(%this, %obj, %user, %amount);
		if(%res == 1)
		{
			if(%l)
			{
				if(%trash)
					%user.modSalvage(1);
				else
					%user.modSalvage(2);
			}
		}
	}
  function Player::activateStuff(%this)
  {
    %client = %this.client;
    %item = %this.tool[%this.currTool];

    if (!isObject(%client) || %client.miniGame != $DefaultMiniGame)
      return Parent::activateStuff(%this);

    if (isObject(%item) && !isObject(%item.image))
      return Parent::activateStuff(%this);

    if (%this.getDamagePercent() >= 1)
      return 0;

    if (getSimTime() - %this.lastActivateTime <= 320)
      %this.activateLevel++;
    else
      %this.activateLevel = 0;

    %this.lastActivateTime = getSimTime();

    if (%this.activateLevel >= 5)
      %this.playThread(3, "activate2");
    else
      %this.playThread(3, "activate");

    %start = %this.getEyePoint();
    %path = vectorScale(%this.getEyeVector(), 6);
    %end = vectorAdd(%start, %path);

    %mask = (
      $TypeMasks::ItemObjectType |
      $TypeMasks::PlayerObjectType |
      $TypeMasks::VehicleObjectType |
      $TypeMasks::FxBrickObjectType
    );

    %exempt = %this;

    if (%this.isMounted())
      %exempt = %this.getObjectMount();

    %ray = containerRayCast(%start, %end, %mask, %exempt);

    if (!%ray)
      return 0;
	if(!(%ray.getType() & $TypeMasks::FxBrickObjectType))
		%ray.onActivate(%this, %client, getWords(%ray, 1, 3), %path);
	return Parent::activateStuff(%this);
   
    //return getWord(%ray, 0);
  }
  function fxDTSBrick::onActivate(%brick, %obj, %client, %pos, %dir)
	{
		if(%brick.getDatablock().isSurvivalBrick)
		{
			centerPrint(%client,"\c6Brick health: " @ mCeil(%brick.health/(mCeil(%brick.getDatablock().getVolume())*2)*100) @ "%",1);
		}
		if(%brick.getDatablock().crateSize > 0)
		{
			if(%obj.lastCrateClick+3000 > getSimTime())
			{
				%obj.scrollIndex++;
				if(%obj.scrollIndex >= %brick.getDatablock().crateSize)
					%obj.scrollIndex = 0;
			}
			%inv = %brick.inventory;
			%client.showCrateInv(%brick);
			%obj.lastCrateClick = getSimTime();
		}
		if(%brick.getDatablock().salvageCrate)
		{
			%obj.crate = %brick;
			%client.showSalvageCrate(%brick);
		}
		if(%brick.getDatablock().isFabricator)
		{
			if(%brick.salvage >0)
			{
				%obj.modSalvage(%brick.salvage);
				%brick.salvage = 0;				
				serverPlay3d(fabricatorSwSound,%brick.getPosition());
			}
		}
		parent::onActivate(%brick, %obj, %client, %pos, %dir);
	}
  function Item::onActivate(%this, %obj, %client, %pos, %vec)
  {
	  if(%this.getDatablock().ammoBox == 1)
	  {
		  %obj.pickupAmmo(%this);
		  return;
	  }
	  if(%this.getDataBlock().image $= "SalvImage")
	  {
		  %x = %this.total;
		  %client.player.modSalvage(%x);
		  %this.delete();
		  return;
	  }
	%obj.pickup(%this);
  }

  function Player::onActivate(%this, %obj, %client, %pos, %vec)
  {
    if (%this == %obj || !%this.getDataBlock().rideAble || %obj.isMounted())
	{
		if(%this.getDatablock() == CratePlayer.getid())
		{
			if(%obj.lastCrateClick+3000 > getSimTime())
			{
				%obj.scrollIndex++;
				if(%obj.scrollIndex >= %this.crateSize)
					%obj.scrollIndex = 0;
			}
			%inv = %this.inventory;
			%client.showCrateInv(%this);
			%obj.lastCrateClick = getSimTime();
		}
		return;
	}


    %pos = %obj.getTransform();

    %obj.setTransform(vectorAdd(%pos, "0 0 100"));
    %this.getDatablock().onCollision(%this, %obj, 0, 0, 1);

    if (!%obj.isMounted())
      %obj.setTransform(%pos);
  }

  function Vehicle::onActivate(%this, %obj, %client, %pos, %vec)
  {
    if (%obj.isMounted())
    {
      Parent::onActivate(%this, %obj, %client, %pos, %vec);
      return;
    }

    %pos = %obj.getTransform();

    %obj.setTransform(vectorAdd(%pos, "0 0 100"));
    //%this.getDatablock().onCollision(%this, %obj, 0, 0, 1);
    WheeledVehicleData::onCollision(%this.getDataBlock(), %this, %obj, 0, 0, 1);

    if (!%obj.isMounted())
    {
      //talk("couldn't mount for some reason");
      %obj.setTransform(%pos);
    }
  }

  function Armor::onCollision(%this, %obj, %col, %vec, %vel, %parent)
  {
    if (%parent || !(%col.getType() & $TypeMasks::ItemObjectType) && !(%col.getType() & $TypeMasks::PlayerObjectType))
      Parent::onCollision(%this, %obj, %col, %vec, %vel);
  }

  function WheeledVehicleData::onCollision(%this, %obj, %col, %vec, %vel, %parent)
  {
    if (%parent)
      Parent::onCollision(%this, %obj, %col, %vec, %vel);
  }
};

activatePackage("ActivatePackage");
