$RoleplayServer::TimeoutTalking = 1000;
$RoleplayServer::RadiusTalking = 26;
$RoleplayServer::RadiusWhispering = 4;
$RoleplayServer::RadiusYelling = 40;
package RS_Package
{
	function serverCmdTeamMessageSent(%this, %msg)
	{
		serverCmdOOC(%this, %msg);
	}

	function serverCmdMessageSent(%this, %msg)
	{
		if(!%this.hasSpawnedOnce || !isObject(%this.player))
		{
			//If they haven't spawned, OOC.
			serverCmdOOC(%this, %msg);
			return;
		}

		if(%msg $= "")
		{
			//Get rid of empty messages.
			return;
		}

		%firstLetter = getSubStr(%msg, 0, 1);
		%rest = getSubStr(%msg, 1, strlen(%msg));

		if(%firstLetter $= "@")
		{
			serverCmdAdminChat(%this, %rest);
			return;
		}

		if(!%this.isAdmin && getSimTime() - %this.lastCommandUse["messageSent"] <= $RoleplayServer::Timeout["Talking"])
		{
			%secondsLeft = mCeil(($RoleplayServer::Timeout["Talking"] - (getSimTime() - %this.lastCommandUse["messageSent"])) / 1000);
			messageClient(%this, '', '<color:DDDDFF>Please wait %1 second%2 to talk again.', %secondsLeft, %secondsLeft == 1 ? "" : "s");
			return;
		}
	
		

		%msg = StripMLControlChars(%msg);
		%caps = strUpr(%msg);
		if(strCmp(%msg,%caps) == 0)
			return serverCmdY(%this,%msg);
		%pos = %this.player.getPosition();
		%image = %this.player.getMountedImage(0);
		%this.lastCommandUse["messageSent"] = getSimTime();
		//If they're talking through a handheld radio.
		if(isObject(%image) && %image.getName() $= "RadioImage")
		{
			if(%this.radioFrequency $= "")
			{
				messageClient(%this, '', '\c7Type \c6/radioHelp\c7 to set up the radio.');
				return;
			}
			for(%i = 0; %i < ClientGroup.getCount(); %i++)
			{
				%client = ClientGroup.getObject(%i);
		
				if(!isObject(%client.player))
					continue;

				if(%client.player.hasRadio() && %client.radioFrequency $= %this.radioFrequency)
				{
					//If they have a radio and are on the same frequency.
					messageClient(%client, '', '<color:6F9922>%1 radios in, "%2"', %this.name, %msg);
					%client.play2D(RadioSound);
				}
				else if(VectorDist(%client.player.getPosition(), %pos) <= $RoleplayServer::Radius["Talking"])
				{
					//Or if they're close enough to hear the voice.
					messageClient(%client, '', '<color:F8D690>%1 radios in, "%2"', %this.name, %msg);
					%client.play2D(RadioSound);
				}
			}

			%this.player.playThread(3,"talk");
			%this.player.schedule(strlen(%msg) * 50, playThread, 3, "root");

			return;
		}

		for(%i = 0; %i < ClientGroup.getCount(); %i++)
		{
			%client = ClientGroup.getObject(%i);
	
			if(!isObject(%client.player))
				continue;
			%dist = $RoleplayServer::Radius["Talking"];
			if(%client.player.getMountedImage(2) == HatHeadsetMountedImage.getID())
				%dist*= 10;
			if(VectorDist(%client.player.getPosition(), %pos) <= %dist)
			{
				messageClient(%client, '', '\c3%1<color:F8D690> says, "%2"', %this.name, %msg);
				//%client.play2D(RoleplayChatSound);
			}
		}
		echo(%this.name @ ":" SPC %msg);
		%this.player.playThread(3,"talk");
		%this.player.schedule(strlen(%msg) * 50, playThread, 3, "root");
	}

	function WeaponImage::onMount(%this, %obj, %slot)
	{
		if(!%this.armReady)
		{
			// If their hand was already up, put it down.
			%obj.playThread(1, "root");
		}

		%client = %obj.client;
		%item = %this.item;

		if(isObject(%client) && %item.roleplayDescription !$= "")
		{
			if(%item.uiName $= "Radio")
			{
				%hasFreq = %client.radioFrequency !$= "";

				if(!%hasFreq)
				{
					messageClient(%client, '', "\c7You don't have a frequency set. Use \c6/setFreq [frequency]\c7. Your radio won't work until you do so.");
				}
			}

			%client.centerPrint("<font:Palatino Linotype:30><color:A5505E>\xab " @ %item.uiName @ (%hasFreq ? " - " @ %client.radioFrequency @ "MHz \xbb" : " \xbb") @ "<br><color:48333E>" @ %item.roleplayDescription, 4);
		}

		return Parent::onMount(%this, %obj, %slot);
	}

	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);

		messageClient(%this, '', "\c7This server uses local chat, use \"y\" to chat globally. Type /rpHelp for more info.");
	}
};

activatePackage(RS_Package);

function Player::hasRadio(%this)
{
	%max = %this.getDatablock().maxTools;

	for(%i = 0; %i < %max; %i++)
	{
		if(%this.tool[%i].uiName $= "Radio")
		{
			return true;
		}
	}

	return false;
}

function serverCmdRPHelp(%this)
{
	messageClient(%this, '', '\c7This server uses a roleplay-lite chat mod');
	messageClient(%this, '', '\c7\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97');

	messageClient(%this, '', '\c7Talking normally produces an in-character message, unless you\'re loading.');
	messageClient(%this, '', '\c7To talk globally, use team chat.');
	messageClient(%this, '', '\c7To yell, type <color:A6130C>/y\c7 before your message.');
	messageClient(%this, '', '\c7To whisper, type <color:A6130C>/w\c7 before your message.');
	messageClient(%this, '', '\c7For help with radios, type <color:A6130C>/radioHelp\c7.');

	messageClient(%this, '', '\c7\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97');
	messageClient(%this, '', '\c7Use the <color:A6130C>PageUp \c7and <color:A6130C>PageDown \c7keys to scroll (by default).');
}

function serverCmdRPCInfo(%this)
{
	serverCmdRPHelp(%this);
}

function serverCmdRadioHelp(%this)
{
	messageClient(%this, '', '\c7Radios are useful for communicating from a distance.');
	messageClient(%this, '', '\c7\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97');

	messageClient(%this, '', '\c7Talking with a Radio item out will radio in to your current frequency.');
	messageClient(%this, '', '\c7To change your frequency, type <color:A6130C>/setFreq [frequency]\c7.');
	messageClient(%this, '', '\c7Those around will be able to hear you talk into your radio.');
	messageClient(%this, '', '\c7Radio messages show up green if heard through a speaker, and yellow if by voice.');

	messageClient(%this, '', '\c7\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97\x97');
	messageClient(%this, '', '\c7Use the <color:A6130C>PageUp \c7and <color:A6130C>PageDown \c7keys to scroll (by default).');
}

function serverCmdOOC(%this, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13, %a14, %a15, %a16, %a17, %a18, %a19, %a20, %a21, %a22, %a23, %a24, %a25, %a26, %a27, %a28, %a29, %a30, %a31, %a32)
{
	if(!%this.isAdmin && getSimTime() - %this.lastCommandUse["ooc"] <= $RoleplayServer::Timeout["Talking"])
	{
		%secondsLeft = mCeil(($RoleplayServer::Timeout["Talking"] - (getSimTime() - %this.lastCommandUse["ooc"])) / 1000);
		messageClient(%this, '', '<bitmap:Add-Ons/Server_Roleplay/res/icons/comment> <color:DDDDFF>Please wait %1 second%2 to use OOC again.', %secondsLeft, %secondsLeft == 1 ? "" : "s");
		return;
	}
	
	%this.lastCommandUse["ooc"] = getSimTime();

	%msg = trim(%a1 SPC %a2 SPC %a3 SPC %a4 SPC %a5 SPC %a6 SPC %a7 SPC %a8 SPC %a9 SPC %a10 SPC %a11 SPC %a12 SPC %a13 SPC %a14 SPC %a15 SPC %a16 SPC %a17 SPC %a18 SPC %a19 SPC %a20 SPC %a21 SPC %a22 SPC %a23 SPC %a24 SPC %a25 SPC %a26 SPC %a27 SPC %a28 SPC %a29 SPC %a30 SPC %a31 SPC %a32);
	%msg = StripMLControlChars(%msg);

	%msg = strreplace(%msg, "https://", "http://");

	if(strpos(%msg, "http://") == 0)
	{
		%msg = getSubStr(%msg, 7, strlen(%msg) - 7);
		%link = firstWord(%msg);
		%rest = restWords(%msg);

		%msg = trim("<a:" @ %link @ ">" @ %link @ "</a>" SPC %rest);
	}

	if(%msg $= "")
	{
		return;
	}

	messageAll('', '%1<color:FFFFFF>\c3%2\c6: %3',"", %this.getPlayerName(), %msg);
	//serverPlay2D(RoleplayChatSound);

}


function serverCmdW(%this, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13, %a14, %a15, %a16, %a17, %a18, %a19, %a20, %a21, %a22, %a23, %a24, %a25, %a26, %a27, %a28, %a29, %a30, %a31, %a32)
{
	if(!isObject(%this.player))
	{
		return;
	}
	
	if(!%this.isAdmin && getSimTime() - %this.lastCommandUse["w"] <= $RoleplayServer::Timeout["Talking"])
	{
		%secondsLeft = mCeil(($RoleplayServer::Timeout["Talking"] - (getSimTime() - %this.lastCommandUse["w"])) / 1000);
		messageClient(%this, '', '<color:DDDDFF>Please wait %1 second%2 to whisper again.', %secondsLeft, %secondsLeft == 1 ? "" : "s");
		return;
	}
	
	%this.lastCommandUse["w"] = getSimTime();

	%msg = trim(%a1 SPC %a2 SPC %a3 SPC %a4 SPC %a5 SPC %a6 SPC %a7 SPC %a8 SPC %a9 SPC %a10 SPC %a11 SPC %a12 SPC %a13 SPC %a14 SPC %a15 SPC %a16 SPC %a17 SPC %a18 SPC %a19 SPC %a20 SPC %a21 SPC %a22 SPC %a23 SPC %a24 SPC %a25 SPC %a26 SPC %a27 SPC %a28 SPC %a29 SPC %a30 SPC %a31 SPC %a32);
	%msg = StripMLControlChars(%msg);

	if(%msg $= "")
	{
		return;
	}


	%pos = %this.player.getPosition();

	for(%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%client = ClientGroup.getObject(%i);

		if(!isObject(%client.player))
			continue;
		%dist = $RoleplayServer::Radius["Whispering"];
		if(%client.player.getMountedImage(2) == HatHeadsetMountedImage.getID())
				%dist*= 5;
		if(VectorDist(%client.player.getPosition(), %pos) <= %dist)
		{
			messageClient(%client, '', '<color:F8D690>%1 whispers, "%2"', %this.name, %msg);
			//%client.play2D(RoleplayChatSound);
		}
	}

}

function serverCmdY(%this, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10, %a11, %a12, %a13, %a14, %a15, %a16, %a17, %a18, %a19, %a20, %a21, %a22, %a23, %a24, %a25, %a26, %a27, %a28, %a29, %a30, %a31, %a32)
{
	if(!isObject(%this.player))
	{
		return;
	}

	if(!%this.isAdmin && getSimTime() - %this.lastCommandUse["y"] <= $RoleplayServer::Timeout["Talking"])
	{
		%secondsLeft = mCeil(($RoleplayServer::Timeout["Talking"] - (getSimTime() - %this.lastCommandUse["y"])) / 1000);
		messageClient(%this, '', '<color:DDDDFF>Please wait %1 second%2 to yell again.', %secondsLeft, %secondsLeft == 1 ? "" : "s");
		return;
	}
	
	%this.lastCommandUse["y"] = getSimTime();

	%msg = trim(%a1 SPC %a2 SPC %a3 SPC %a4 SPC %a5 SPC %a6 SPC %a7 SPC %a8 SPC %a9 SPC %a10 SPC %a11 SPC %a12 SPC %a13 SPC %a14 SPC %a15 SPC %a16 SPC %a17 SPC %a18 SPC %a19 SPC %a20 SPC %a21 SPC %a22 SPC %a23 SPC %a24 SPC %a25 SPC %a26 SPC %a27 SPC %a28 SPC %a29 SPC %a30 SPC %a31 SPC %a32);
	%msg = StripMLControlChars(%msg);

	if(%msg $= "")
	{
		return;
	}

	%pos = %this.player.getPosition();

	for(%i = 0; %i < ClientGroup.getCount(); %i++)
	{
		%client = ClientGroup.getObject(%i);

		if(!isObject(%client.player))
			continue;
		%dist = $RoleplayServer::Radius["Yelling"];
		if(%client.player.getMountedImage(2) == HatHeadsetMountedImage.getID())
				%dist*= 10;
		if(VectorDist(%client.player.getPosition(), %pos) <= %dist)
		{
			messageClient(%client, '', '\c3%1<color:F8D690> yells, "%2"', %this.name, %msg);
			//%client.play2D(RoleplayChatSound);
		}
	}

}
function serverCmdSetFreq(%this, %freq)
{
	if(!isObject(%this.player))
	{
		return;
	}

	%image = %this.player.getMountedImage(0);

	if(!isObject(%image) || %image.getName() !$= "RadioImage")
	{
		messageClient(%this, '', "\c7You must be holding a radio.");
		return;
	}

	if(!%this.isAdmin && getSimTime() - %this.lastCommandUse["setFreq"] <= $RoleplayServer::Timeout["SetFreq"])
	{
		%secondsLeft = mCeil(($RoleplayServer::Timeout["SetFreq"] - (getSimTime() - %this.lastCommandUse["setFreq"])) / 1000);
		messageClient(%this, '', '<color:DDDDFF>Please wait %1 second%2 to set your frequency again.', %secondsLeft, %secondsLeft == 1 ? "" : "s");
		return;
	}

	%this.lastCommandUse["setFreq"] = getSimTime();

	%freq = mFloatLength(%freq, 1);

	if(%freq < 88)
	{
		messageClient(%this, '', '\c7The frequency must be higher than 88.');
		return;
	}

	if(%freq > 188)
	{
		messageClient(%this, '', '\c7The frequency must be lower than 188.');
		return;
	}

	%this.radioFrequency = %freq;
	messageClient(%this, '', '\c7You have set your radio\'s frequency to \c6%1\c7.', %this.radioFrequency);

}