datablock ItemData(LootGasCanItem : LootPebblesItem)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/gascan.dts";
	uiName = "Gas Can";

	doColorShift = 1;
	colorShiftColor = "0.9 0.1 0.1 1";

	itemDesc = "A canister of gas.";
	invMass = 25;
	recycleValue = 6;

	image = LootGasCanImage;
};

datablock ShapeBaseImageData(LootGasCanImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/gascan.dts";
	item = LootGasCanItem;

	doColorShift = LootGasCanItem.doColorShift;
	colorShiftColor = LootGasCanItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[0] = "Ready";
};

function LootGasCanImage::onUse(%this, %obj, %slot)
{
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getEyeVector(), 6));
	%ray = containerRayCast(%start, %end,
		$TypeMasks::VehicleObjectType |
		$TypeMasks::FxBrickObjectType
	);

	%col = getWord(%ray, 0);
	if(isObject(%col) && %col.getType() & $TypeMasks::VehicleObjectType)
	{
		%col.fuel += 0.5 + getRandom();
		if (%col.fuel > 3)
			%col.fuel = 3;
		%obj.tool[%obj.currTool] = 0;
		messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
		%obj.unMountImage(0);
	}
}
