

datablock AudioProfile(shrapGrenExplosion0Sound)
{
   filename    = "./Explosion01.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(shrapGrenExplosion1Sound)
{
   filename    = "./Explosion02.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(shrapGrenExplosion2Sound)
{
   filename    = "./grenade_blast_2.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(shrapGrenBounceSound)
{
   filename    = "./shrapGrenBounce.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(ThrowingSound)
{
   filename    = "./Throwing.2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock DebrisData(shrapGrenPinDebris)
{
	shapeFile = "./frag_pin.dts";
	lifetime = 5.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(shrapGrenTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 750;
	lifetimeVarianceMS	= 150;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 0.03";
	colors[1]	= "1 1 0 0.09";
	colors[2]	= "0.7 0.7 0.7 0";
	sizes[0]	= 0.0;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.02;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(shrapGrenTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 2;
   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;
   ejectionOffset = 0;
   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = shrapGrenTrailParticle;
};

datablock ParticleData(shrapGrenTrailBParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 400;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   	colors[0]     = "0.95 0.9 0.8 0.6";
   	colors[1]     = "0.1 0.05 0.025 0.4";
   	colors[2]     = "0.95 0.9 0.8 0.6";
	sizes[0]	= 0.0;
	sizes[1]	= 0.65;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(shrapGrenTrailBEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 2;
   ejectionVelocity = 5; //0.25;
   velocityVariance = 0; //0.10;
   ejectionOffset = 1;
   thetaMin         = 00;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;

   particles = shrapGrenTrailBParticle;
};

datablock ParticleData(shrapGrenExplosionParticle)
{
	dragCoefficient		= 3.5;
	windCoefficient		= 3.5;
	gravityCoefficient	= -1;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 00;
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "1 1 1 0.1";
   colors[1]     = "0.9 0.5 0.0 0.3";
   colors[2]     = "0.1 0.05 0.025 0.1";
   colors[3]     = "0.1 0.05 0.025 0.0";

	sizes[0]	= 4.0;
	sizes[1]	= 6.3;
   sizes[2]	= 6.5;
   sizes[3]	= 4.5;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 0.8;
   times[3]	= 1.0;
};

datablock ParticleData(shrapGrenFlashParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 60;
	lifetimeVarianceMS   = 40;
	textureName          = "./blastflash2";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]     = "1 1 1 1";
	colors[1]     = "0.9 0.5 0.0 0.9";

	sizes[0]      = 10.55;
	sizes[1]      = 18.55;

	useInvAlpha = false;
};
datablock ParticleEmitterData(shrapGrenFlashEmitter)
{
   ejectionPeriodMS = 20;
   periodVarianceMS = 10;
   lifeTimeMS	   = 121;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 2.0;
   thetaMin         = 00;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "shrapGrenFlashParticle";
};

datablock ParticleEmitterData(shrapGrenExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 4;
   velocityVariance = 3.0;
   ejectionOffset   = 2.0;
   thetaMin         = 00;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "shrapGrenExplosionParticle";
};

datablock ParticleData(shrapGrenExplosionParticle2)
{
	dragCoefficient		= 5.0;
	windCoefficient		= 1.0;
	gravityCoefficient	= -0.50;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.95 0.9 0.8 0.6";
   colors[1]     = "0.1 0.05 0.025 0.4";
   colors[2]     = "0.1 0.05 0.025 0.0";

	sizes[0]	= 7.0;
	sizes[1]	= 10.0;
   sizes[2]	= 13.5;

	times[0]	= 0.0;
	times[1]	= 0.01;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(shrapGrenExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 2.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 30;
   phiVariance      = 32;
   overrideAdvance = false;
   particles = "shrapGrenExplosionParticle2";
};


datablock ExplosionData(shrapGrenExplosion : gunExplosion)
{
   //explosionShape = "";

   explosionShape = "add-ons/weapon_rocket_launcher/explosionSphere1.dts";

   particleEmitter = shrapGrenFlashEmitter;
   soundProfile = shrapGrenExplosion2Sound;

   emitter[0] = shrapGrenFlashEmitter;
   emitter[1] = shrapGrenExplosionEmitter2;
   emitter[2] = shrapGrenExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 25;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 1";

   damageRadius = 4;
   radiusDamage = 160;

   impulseRadius = 5;
   impulseForce = 400;
};

datablock ExplosionData(shrapGrenSmallExplosion : shrapGrenExplosion)
{
   //explosionShape = "";

   explosionShape = "";

   particleEmitter = shrapGrenFlashEmitter;
   soundProfile = shrapGrenExplosion1Sound;

   emitter[0] = shrapGrenFlashEmitter;
   emitter[1] = shrapGrenExplosionEmitter2;
   emitter[2] = shrapGrenExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 25;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 1";

   damageRadius = 8;
   radiusDamage = 25;

   impulseRadius = 9;
   impulseForce = 1000;
};

//projectile
AddDamageType("shrapGrenDirect",   '<bitmap:add-ons/Gamemode_Survival/shapes/ci_shrapGren> %1',    '%2 <bitmap:add-ons/Gamemode_Survival/shapes/ci_shrapGren> %1',1,1);
datablock ProjectileData(shrapGrenProjectile)
{
   projectileShapeName = "./frag_projectile.dts";
   directDamage        = 30;
   directDamageType  = $DamageType::shrapGrenDirect;
   radiusDamageType  = $DamageType::shrapGrenDirect;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = "";
   particleEmitter     = shrapGrenTrailEmitter;

   brickExplosionRadius = 10;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;             
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 25;
   velInheritFactor    = 0;
   explodeOnDeath = true;
   explodeOnPlayerImpact = false;

   armingDelay         = 4000; //4 second fuse 
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.1;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};

datablock ProjectileData(shrapGrenClusterProjectile : shrapGrenProjectile)
{
   projectileShapeName = "";
   directDamage        = 0;
   directDamageType  = $DamageType::shrapGrenDirect;
   radiusDamageType  = $DamageType::shrapGrenDirect;
   explosion           = shrapGrenSmallExplosion;
   particleEmitter     = shrapGrenTrailBEmitter;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   muzzleVelocity      = 25;
   bounceElasticity    = 1;
   bounceFriction      = 0;

   armingDelay         = 0; //4 second fuse 
   lifetime            = 400;
   fadeDelay           = 500;

   hasLight    = false;
   uiName = "";
};


datablock ProjectileData(shrapGrenTrailProjectile : shrapGrenProjectile)
{
   projectileShapeName = "";
   directDamage        = 0;
   directDamageType  = $DamageType::shrapGrenDirect;
   radiusDamageType  = $DamageType::shrapGrenDirect;
   explosion           = "";
   particleEmitter     = shrapGrenTrailBEmitter;
   muzzleVelocity      = 25;
   impactImpulse	   = 0;
   verticalImpulse	   = 0;
   bounceElasticity    = 1;
   bounceFriction      = 0;

   armingDelay         = 0; //4 second fuse 
   lifetime            = 400;
   fadeDelay           = 500;

   hasLight    = false;
   uiName = "";
};

//////////
// item //
//////////
datablock ItemData(shrapGrenItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./frag_grenade.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Frag Grenade";
	iconName = "./icon_shrapGren";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

   maxmag = 1;
   //ammotype = "Frag Grenades";
   reload = true;

	 // Dynamic properties defined by the scripts
	image = shrapGrenImage;
	canDrop = true;
};

datablock ShapeBaseImageData(shrapGrenImage)
{
   // Basic Item properties
   shapeFile = "./frag_grenade.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "-0.03 0 0.1";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = shrapGrenItem;
   ammo = " ";
   projectile = shrapGrenProjectile;
   projectileType = Projectile;

   	casing = shrapGrenPinDebris;
	shellExitDir        = "-2.0 1.0 1.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1 1 1 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.05;
	stateTransitionOnTimeout[0]	= "AmmoCheck";
	stateScript[0]                  = "onActivate";
	stateSequence[0]		= "pinout";
	stateSound[0]                    = weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Tick";
	stateScript[1]                  = "onReady";
	stateTransitionOnTimeout[1]	= "Ready";
	stateWaitForTimeout[1]		= false;
	stateSequence[1]		= "open";
	stateTimeoutValue[1]		= 0.4;
	stateAllowImageChange[1]	= true;

	stateName[2]			= "Tick";
	stateTransitionOnTriggerUp[2]	= "Charge";
	stateAllowImageChange[2]	= false;
	stateSequence[2]		= "pinout";
	stateScript[2]                  = "onPinDrop";
   	stateEjectShell[2]               = true;

	stateName[3]			= "AmmoCheck";
	stateTimeoutValue[3]		= 0.01;
	stateSequence[3]		= "pinout";
	stateTransitionOnTimeout[3]	= "Ready";
	stateAllowImageChange[3]	= false;
	
	stateName[4]                    = "Charge";
	stateWaitForTimeout[4]		= false;
	stateTimeoutValue[4]		= 0.01;
	stateScript[4]                  = "onCharge";
	stateTransitionOnTimeout[4]	= "Armed";
	stateAllowImageChange[4]        = true;
	
	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.1;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

	stateName[6]			= "Armed";
	stateScript[6]			= "onArmed";
	stateTransitionOnTimeout[6]	= "Fire";
	stateWaitForTimeout[6]		= false;
	stateScript[6]                  = "onCharge";
	stateTimeoutValue[6]		= 0.12;
	stateAllowImageChange[6]	= true;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Activate";
	stateTimeoutValue[7]		= 0.12;
	stateFire[7]			= true;
	stateSound[7]				= throwingsound;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Empty";
   	stateAllowImageChange[8]         = true;
   	stateScript[8]                   = "onEmpty";
   	stateTransitionOnAmmo[8]         = "Reload";
	stateTimeoutValue[8]		= 0.01;
	stateTransitionOnTimeout[8]	= "Empty";
   	//stateSequence[8]                 = "noammo";

   	stateName[9]                     = "Reload";
	stateTransitionOnTimeout[9]	= "ReloadReady";
   	stateAllowImageChange[9]         = true;
	stateTimeoutValue[9]		= 0.01;
  	//stateSequence[9]                 = "noammo";

   	stateName[10]                     = "ReloadReady";
   	stateTransitionOnTimeout[10]      = "Activate";
   	stateTimeoutValue[10]             = 0.01;
   	stateAllowImageChange[10]         = true;
   	stateScript[10]                   = "onReload";
};

package shrapGrenPackage
{
	function projectile::onAdd(%obj,%a,%b)
	{
		parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock $= "shrapGrenProjectile")
		{
			if(!%obj.isBurned)
			{
		         //%original = %obj.getDatablock().lifetime; Doesn't work for some reason
			 %oldLT = 4000;
		 	 //echo("Original is:" SPC %oldLT);
		 	 %cookTime = %obj.client.player.chargeTime;
		 	 //echo("Cooktime is:" SPC %cookTime);
		 	 %new = %oldLT - %cookTime;
		 	 //echo("Difference is:" SPC %new);
			 %obj.schedule(%new,"explode"); //Makes it so it explodes quicker if you held it longer
			}
		}
		parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock $= "shrapGrenClusterProjectile")
		{
			if(!%obj.isBurned)
			{
		         //%original = %obj.getDatablock().lifetime; Doesn't work for some reason
			 %oldLT = 400;
		 	 //echo("Original is:" SPC %oldLT);
		 	 %cookTime = %obj.client.player.chargeTime;
		 	 //echo("Cooktime is:" SPC %cookTime);
		 	 %new = %oldLT - (getRandom(0,400));
		 	 //echo("Difference is:" SPC %new);
			 %obj.schedule(%new,"explode"); //Makes it so it explodes quicker if you held it longer
			}
		}
		parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock $= "shrapGrenTrailProjectile")
		{
			if(!%obj.isBurned)
			{
		         //%original = %obj.getDatablock().lifetime; Doesn't work for some reason
			 %oldLT = 400;
		 	 //echo("Original is:" SPC %oldLT);
		 	 %cookTime = %obj.client.player.chargeTime;
		 	 //echo("Cooktime is:" SPC %cookTime);
		 	 %new = %oldLT - (getRandom(100,400));
		 	 //echo("Difference is:" SPC %new);
			 %obj.schedule(%new,"explode"); //Makes it so it explodes quicker if you held it longer
			}
		}
	}

};
activatePackage(shrapGrenPackage);


function shrapGrenImage::onMount( %this, %obj, %slot )
{parent::onMount(%this,%obj,%slot);}

function shrapGrenImage::onUnMount( %this, %obj, %slot )
{parent::onUnMount(%this,%obj,%slot);}

function shrapGrenImage::onPinDrop(%this, %obj, %slot)
{
	serverPlay3D(shrapGrenBounceSound,%obj.getTransform());
	%obj.playthread(2,shiftleft);
   %obj.chargeStart = getSimTime();
   if(!isEventPending(%obj.burnSched))
	{
      %obj.burnSched = schedule(4000,0,"burnedIt",%obj,%slot);
	  %obj.warnTime = "4 Seconds";
	  %obj.warnSched = schedule(100,0,sendCenterNade,%obj.client);
	}
}

function shrapGrenImage::onActivate(%this, %obj, %slot)
{
	%obj.playthread(2, plant);
}

function shrapGrenImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2,shiftaway);
}

function sendCenterNade(%client)
{
	if(isObject(%client.player) && %client.player.warntime !$= "0 seconds")
	{
		commandtoclient(%client,'centerprint',"\c5"@%client.player.warnTime@"\c6 cooking time left.",0.15);
		%client.player.warntime = getWord(%client.player.warntime,0)-0.1@" seconds";
		if(getWord(%client.player.warnTime,0) == 1)
			%client.player.warnTime = "1 second";
			
		%client.player.warnsched = schedule(100,0,sendCenterNade,%client);
	}
}

function shrapGrenImage::onReload(%this, %obj, %slot)
{
	serverPlay3D(shrapGrenBounceSound,%obj.getTransform());
}

function shrapGrenProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(shrapGrenBounceSound,%obj.getTransform());
}

function shrapGrenImage::onFire(%this, %obj, %slot)
{
   if(%obj.getDamagePercent() > 1.0)
   {
      return;
   }

	cancel(%obj.burnSched);
	cancel(%obj.warnSched);
	serverPlay3D(ThrowingSound,%obj.getTransform());
	%obj.playthread(2,shiftto);
	%obj.chargeEnd = getSimTime();
	%obj.chargeTime = %obj.chargeEnd - %obj.chargeStart;
	%obj.thrown = 1;
	Parent::OnFire(%this, %obj, %slot);

	%obj.thrown = 0;

	%obj.tool[%obj.currTool] = 0;
	messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
	%obj.unMountImage(0);
}

function shrapGrenImage::onUnMount(%this,%obj,%slot)
{
	if(!%obj.thrown)
	{
		cancel(%obj.burnSched);
		cancel(%obj.warnsched);
		%obj.playThread(2,root);
	}
}

function shrapGrenImage::onEmpty(%this,%obj,%slot)
{
   if( $hl2Weapons::Ammo && %obj.toolAmmo[%this.item.ammotype] < 1 )
   {
      return;
   }

   if(%obj.toolMag[%obj.currTool] < 1)
   {
      serverCmdLight(%obj.client);
   }
}

//If they cooked it too long, it explodes in their hands
function burnedIt(%player,%slot)
{
	cancel(%player.warnSched);
      %pos = %player.getPosition();
      %currSlot = %player.lastFragSlot;
	%player.tool[%currSlot] = 0;
	%player.weaponCount--;
	messageClient(%player.client,'MsgItemPickup','',%currSlot,0);
	%player.unMountImage(%slot);
	serverCmdUnUseTool(%player.client);
      %posx = getWord(%pos,0);
      %posy = getWord(%pos,1);
      %posz = getWord(%pos,2);

      %spawnpoint = %posx SPC %posy SPC %posz + 2;

      %burned = new Projectile()
      {
	 datablock = shrapGrenProjectile;
	 initialVelocity = 0;
	 initialPosition = %spawnpoint;
	 sourceObject = %player;
	 sourceSlot = %player.lastFragSlot;
	 client = %player.client;
	 isBurned = true;
      };
      missionCleanup.add(%burned);
      %burned.explode();
}

//-------------
// Shrapnel
//-------------

function shrapGrenprojectile::onExplode(%this,%obj)
{
   parent::onExplode(%this, %obj);
   //echo("Grenade Explosion");
   %shrapData = ShrapGrenClusterProjectile;
   %position = %obj.getPosition();

   %sound = shrapGrenExplosion2Sound;
   serverPlay3D(%sound,%obj.getTransform());
   %shards = 10;

   for(%numbar=0; %numbar<%shards; %numbar++)
   {
      %vector = %position;

      %x = (getRandom(-6,6) - 0.5) * 3.141592653;
      %y = (getRandom(-6,6) - 0.5) * 3.141592653;
      %z = (getRandom(-6,6) - 0.5) * 3.141592653;

      //spawn them in random sphere locations.

	if(%z < 0)
	{
		%z = randNegate(%z); //Randomly Negates Negative Z (Up/Down) Velocities to make it spread more evenly
	}

      %velocity = %x SPC %y SPC %z;

      %shraps = new projectile()
      {
	 dataBlock = %shrapData;
	 initialVelocity = %velocity;
	 initialPosition = %position;
	 sourceObject = %obj;
	 sourceSlot = %obj.client.player.lastFragslot;
	 client = %obj.client;
      };
      MissionCleanup.add(%shraps);
      //echo(%obj.client.getplayername());
      //echo(%obj.client.player.getID());
   }
   //echo("Grenade Explosion");
   %shrapData = ShrapGrenTrailProjectile;
   %position = %obj.getPosition();

   %sound = shrapGrenExplosion2Sound;
   serverPlay3D(%sound,%obj.getTransform());
   %shards = 7;

   for(%numbar=0; %numbar<%shards; %numbar++)
   {
      %vector = %position;

      %x = (getRandom(-12,12) - 0.5) * 3.141592653;
      %y = (getRandom(-12,12) - 0.5) * 3.141592653;
      %z = (getRandom(-12,12) - 0.5) * 3.141592653;

      //spawn them in random sphere locations.

	if(%z < 0)
	{
		%z = randNegate(%z); //Randomly Negates Negative Z (Up/Down) Velocities to make it spread more evenly
	}

      %velocity = %x SPC %y SPC %z;

      %shraps = new projectile()
      {
	 dataBlock = %shrapData;
	 initialVelocity = %velocity;
	 initialPosition = %position;
	 sourceObject = %obj;
	 sourceSlot = %obj.client.player.lastFragslot;
	 client = %obj.client;
      };
      MissionCleanup.add(%shraps);
      //echo(%obj.client.getplayername());
      //echo(%obj.client.player.getID());
   }
}

function ShrapProjectile::onCollision(%this,%obj,%col,%fade,%pos,%norm)
{
	if(%col.getClassName() $= "Player")
		%obj.setDataBlock(ShrapProjectileCol);
	else
	{
		%obj.numBounces++;
		serverPlay3D(hammerHitSound,%obj.getTransform());
		if(vectorDist(%obj.lastBounce,getSimTime()) < 200 || %obj.numBounces >= 2)
		{
			%obj.schedule(10,"delete");
			return;
		}
		%obj.lastBounce = getSimTime();
	}
	Parent::onCollision(%this,%obj,%col,%fade,%pos,%norm);
}

function ShrapProjectile::Damage(%this,%obj,%col,%fade,%pos,%norm)
{
	%bounces = %obj.numBounces;
	%velocity = %obj.getVelocity();
	//echo(%velocity);
	%damage = %this.directDamage-(%bounces*3)+mFloor((%velocity/2));	
	//echo(%damage);
	%col.damage(%obj,%pos,%damage,%this.directDamageType);
}

function randNegate(%x)
{
   %rand = getRandom(1,100);
   if(%rand >= 50)
      return %x;

   if(%rand < 50)
   {
      %x = %x * (-1);
      return %x;
   }
}