function player::mountHat(%obj,%image)
{
  %client = %obj.client;
  %player = %obj;
  if(isObject(%player))
  {
    if(%player.getMountedImage(2) $= nametoID(%image)) %player.unmountImage(2);
    else
    {
      %player.unmountImage(2);
	    echo(%image.getID());
      %player.mountImage(%image,2);
	  %obj.tool[%obj.currTool] = 0;
	  messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
	  %obj.unMountImage(0);
    }
  }
}
datablock ItemData(HatOutlawItem)
{
  uiName = "Outlaw Hat";
  iconName = "Add-Ons/GameMode_Survival/shapes/outlaw/outlaw";
  image = HatOutlawImage;
  category = "Tools";
  className = "Weapon";
  shapeFile = "Add-Ons/GameMode_Survival/shapes/outlaw/outlaw.dts";
  itemDesc = "Boosts revolver effectiveness.";
  mass = 0.5;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  canDrop = true;
};

//### Item Image

datablock ShapeBaseImageData(HatOutlawImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/outlaw/outlaw.dts";
  emap = true;
  mountPoint = 0;
  className = "WeaponImage";
  item = HatOutlawItem;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTriggerUp[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

datablock ShapeBaseImageData(HatOutlawMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/outlaw/outlaw.dts";
  emap = true;
  mountPoint = $HeadSlot;
  isHat = true;
  eyeOffset = "0 0 -1000";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Idle";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Idle";
  stateAllowImageChange[1] = true;
};

//### Functions

function HatOutlawImage::onFire(%this,%obj,%slot)
{
  %client = %obj.client;
  %player = %obj;
  if(isObject(%player))
  {
    if(%player.getMountedImage(2) $= nametoID(HatOutlawMountedImage)) %player.unmountImage(2);
    else
    {
      %player.unmountImage(2);
      %player.mountImage(HatOutlawMountedImage,2);
    }
  }
}

function HatOutlawMountedImage::onMount(%this,%obj,%slot) {
 %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
 }
function HatOutlawMountedImage::onUnMount(%this,%obj,%slot) {  }


datablock ItemData(HatSkimaskItem : HatOutlawItem)
{
  uiName = "Ski Mask";
  iconName = "Add-Ons/GameMode_Survival/shapes/skimask/skimaskIcon";
  image = HatSkimaskImage;
  shapeFile = "Add-Ons/GameMode_Survival/shapes/skimask/skimask.dts";
  itemDesc = "Allows you to open one locked door.";
};

//### Item Image

datablock ShapeBaseImageData(HatSkimaskImage : HatOutlawImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/skimask/skimask.dts";
  item = HatSkimaskItem;
};

datablock ShapeBaseImageData(HatSkimaskMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/skimask/skimask.dts";
  isHat = true;
  mountPoint = $HeadSlot;
  eyeOffset = "0 0 -1000";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
};

//### Functions

function HatSkimaskImage::onFire(%this,%obj,%slot)
{
   %obj.mountHat(HatSkimaskMountedImage);
}

function HatSkimaskMountedImage::onMount(%this,%obj,%slot) {
 %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
 }
function HatSkimaskMountedImage::onUnMount(%this,%obj,%slot) {  }


datablock ItemData(HatPoliceItem : HatOutlawItem)
{
  uiName = "Police Hat";
  iconName = "Add-Ons/GameMode_Survival/shapes/police/police";
  image = HatpoliceImage;
  shapeFile = "Add-Ons/GameMode_Survival/shapes/police/police.dts";
  itemDesc = "Boosts damage absorbed by vests.";
};
//### Item Image
datablock ShapeBaseImageData(HatpoliceImage : HatOutlawImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/police/police.dts";
  item = HatpoliceItem;
};

datablock ShapeBaseImageData(HatpoliceMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/police/police.dts";
  isHat = true;
  mountPoint = $HeadSlot;
  eyeOffset = "0 0 -1000";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
};

//### Functions

function HatpoliceImage::onFire(%this,%obj,%slot)
{
   %obj.mountHat(HatpoliceMountedImage);
}

function HatpoliceMountedImage::onMount(%this,%obj,%slot) {
 %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
 }
function HatpoliceMountedImage::onUnMount(%this,%obj,%slot) {  }


datablock ItemData(HatHeadsetItem : HatOutlawItem)
{
  uiName = "Headset";
  iconName = "Add-Ons/GameMode_Survival/shapes/Headset/Headset";
  image = HatHeadsetImage;
  shapeFile = "Add-Ons/GameMode_Survival/shapes/Headset/Headset.dts";
  itemDesc = "Functions as a radio and greatly extends hearing range.";
};
//### Item Image
datablock ShapeBaseImageData(HatHeadsetImage : HatOutlawImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/Headset/Headset.dts";
  item = HatHeadsetItem;
};

datablock ShapeBaseImageData(HatHeadsetMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/Headset/Headset.dts";
  isHat = true;
  mountPoint = $HeadSlot;
  eyeOffset = "0 0 -1000";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
};

//### Functions

function HatHeadsetImage::onFire(%this,%obj,%slot)
{
   %obj.mountHat(HatHeadsetMountedImage);
}

function HatHeadsetMountedImage::onMount(%this,%obj,%slot) {
 %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
 }
function HatHeadsetMountedImage::onUnMount(%this,%obj,%slot) {  }


datablock ItemData(HathelmetItem : HatOutlawItem)
{
  uiName = "Helmet";
  iconName = "Add-Ons/GameMode_Survival/shapes/helmet/helmet";
  image = HathelmetImage;
  shapeFile = "Add-Ons/GameMode_Survival/shapes/helmet/helmet.dts";
  itemDesc = "Reduces headshot damage.";
};
//### Item Image
datablock ShapeBaseImageData(HathelmetImage : HatOutlawImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/helmet/helmet.dts";
  item = HathelmetItem;
};

datablock ShapeBaseImageData(HathelmetMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/helmet/helmet.dts";
  isHat = true;
  mountPoint = $HeadSlot;
  eyeOffset = "0 0 -1000";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";
};

//### Functions

function HathelmetImage::onFire(%this,%obj,%slot)
{
   %obj.mountHat(HathelmetMountedImage);
}

function HathelmetMountedImage::onMount(%this,%obj,%slot) {
 %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
 }
function HathelmetMountedImage::onUnMount(%this,%obj,%slot) {  }