datablock itemData( lootRagItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/rag.dts";
	uiName = "Rag";
	image = lootRagImage;
	doColorShift = true;
	colorShiftColor = "0.85 0.85 0.85 1";
	itemDesc = "Can use as a bandage.";
	iconName = "Add-ons/Gamemode_Survival/shapes/icon_bandage";
	invMass = 7;
};

datablock itemData( lootBandageItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/rag.dts";
	uiName = "Bandage";
	image = lootBandageImage;
	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.9 1";
	iconName = "Add-ons/Gamemode_Survival/shapes/icon_bandage";
	itemDesc = "Stops bleeding.";
	invMass = 3;
	//Remember to scale it
};

datablock ShapeBaseImageData(LootBandageImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/rag.dts";
	item = LootBandageItem;

	doColorShift = LootBandageItem.doColorShift;
	colorShiftColor = LootBandageItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[0] = "Ready";
};

datablock ShapeBaseImageData(lootRagImage : lootBandageImage)
{
	item = LootRagItem;

	doColorShift = LootRagItem.doColorShift;
	colorShiftColor = LootRagItem.colorShiftColor;
};

function LootBandageImage::healLoop(%this, %obj)
{
	%bandageSlot = %obj.currTool;
	%client = %obj.client;
	%tool = %obj.tool[%bandageSlot];
	
	if(isObject(%tool) && %tool.getID() == %this.item.getID())
	{
		%time = 6;
		%obj.zombieMedpackUse += 0.1;
		
		if(%obj.zombieMedpackUse >= %time)
		{
				%obj.pseudoHealth = 0;
				%obj.setDamageLevel(%obj.getDamageLevel() - 40);
				%obj.tool[%bandageSlot] = 0;
				%obj.weaponCount--;
				
				if(isObject(%client))
				{
					messageClient(%client, 'MsgItemPickup', '', %bandageSlot, 0);
					%client.setControlObject(%obj);
				}
				
				%obj.unMountImage(%slot);
				
				if(!isObject(%obj.getObjectMount()))
				{
					%obj.playThread(0, "root");
					%obj.playThread(1, "root");
				}
				
				%client.zombieMedpackting = false;
				%obj.zombieMedpackUse = false;
				cancel(%obj.zombieMedpackSched);
		}
		else
		{
			if(!isObject(%obj.getObjectMount()) && (%obj.zombieMedpackUse * 10) % 10 == 0)
			{
				if(getRandom(0, 1))
				{
					%obj.playThread(0, "activate");
				}
				else
				{
					%obj.playThread(3, "activate2");
				}
			}
			
			if(isObject(%client))
			{
				%bars = "<color:ffaaaa>";
				%div = 20;
				%tens = mFloor((%obj.zombieMedpackUse / %time) * %div);
				
				for(%a = 0; %a < %div; %a++)
				{
					if(%a == (%div - %tens))
					{
						%bars = %bars @ "<color:aaffaa>";
					}
					
					%bars = %bars @ "|";
				}
				
				commandToClient(%client, 'centerPrint', %bars, 0.25);
			}
			
			cancel(%obj.zombieMedpackSched);
			%obj.zombieMedpackSched = %this.schedule(100, "healLoop", %obj);
			
		}
	}
	else
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "<color:ffaaaa>Heal Aborted!", 1);
			%client.setControlObject(%obj);
		}
		
		cancel(%obj.zombieMedpackSched);
	}
}
function LootRagImage::healLoop(%this, %obj)
{
	%bandageSlot = %obj.currTool;
	%client = %obj.client;
	%tool = %obj.tool[%bandageSlot];
	
	if(isObject(%tool) && %tool.getID() == %this.item.getID())
	{
		%time = 6;
		%obj.zombieMedpackUse += 0.1;
		
		if(%obj.zombieMedpackUse >= %time)
		{
				%obj.pseudoHealth = 0;
				%obj.setDamageLevel(%obj.getDamageLevel() - 20);
				%obj.tool[%bandageSlot] = 0;
				%obj.weaponCount--;
				
				if(isObject(%client))
				{
					messageClient(%client, 'MsgItemPickup', '', %bandageSlot, 0);
					%client.setControlObject(%obj);
				}
				
				%obj.unMountImage(%slot);
				
				if(!isObject(%obj.getObjectMount()))
				{
					%obj.playThread(0, "root");
					%obj.playThread(1, "root");
				}
				
				%client.zombieMedpackting = false;
				%obj.zombieMedpackUse = false;
				cancel(%obj.zombieMedpackSched);
		}
		else
		{
			if(!isObject(%obj.getObjectMount()) && (%obj.zombieMedpackUse * 10) % 10 == 0)
			{
				if(getRandom(0, 1))
				{
					%obj.playThread(0, "activate");
				}
				else
				{
					%obj.playThread(3, "activate2");
				}
			}
			
			if(isObject(%client))
			{
				%bars = "<color:ffaaaa>";
				%div = 20;
				%tens = mFloor((%obj.zombieMedpackUse / %time) * %div);
				
				for(%a = 0; %a < %div; %a++)
				{
					if(%a == (%div - %tens))
					{
						%bars = %bars @ "<color:aaffaa>";
					}
					
					%bars = %bars @ "|";
				}
				
				commandToClient(%client, 'centerPrint', %bars, 0.25);
			}
			
			cancel(%obj.zombieMedpackSched);
			%obj.zombieMedpackSched = %this.schedule(100, "healLoop", %obj);
			
		}
	}
	else
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "<color:ffaaaa>Heal Aborted!", 1);
			%client.setControlObject(%obj);
		}
		
		cancel(%obj.zombieMedpackSched);
	}
}
function LootBandageImage::onUse(%this, %obj, %slot)
{
	%client = %obj.client;
	
	if(%obj.getDamageLevel() < 1.0)
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c5You are not injured.", 1);
		}
	}
	else
	{
		if(isObject(%client))
		{
			%client.zombieMedpackting = true;
			%client.camera.setOrbitMode(%obj, %obj.getTransform(), 0.5, 8, 8, 1);
			%client.camera.mode = "Orbit";
			%client.setControlObject(%client.camera);
		}
		%this.healLoop(%obj);
	}
}

function LootRagImage::onUse(%this, %obj, %slot)
{

	%client = %obj.client;
	
	if(%obj.getDamageLevel() < 1.0)
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c5You are not injured.", 1);
		}
	}
	else
	{
		if(isObject(%client))
		{
			%client.zombieMedpackting = true;
			%client.camera.setOrbitMode(%obj, %obj.getTransform(), 0.5, 8, 8, 1);
			%client.camera.mode = "Orbit";
			%client.setControlObject(%client.camera);
		}
		%this.healLoop(%obj);
	}
}