// ============================================================
// Project				:	Item_PillBottle
// Author				:	Iban
// ============================================================
// Table of Contents
// 
// 1. Objects
// 2. Script
// ============================================================

// ============================================================
// Section 1 : Objects
// ============================================================
if(!isObject(poisonPillsDebris))
{
	datablock DebrisData(poisonPillsDebris)
	{
		shapeFile = "Add-Ons/gamemode_survival/shapes/cap.2.dts";
		lifetime = 5.0;
		minSpinSpeed = -400.0;
		maxSpinSpeed = 200.0;
		elasticity = 0.5;
		friction = 0.2;
		numBounces = 3;
		staticOnMaxBounce = true;
		snapOnMaxBounce = false;
		fade = true;
		gravModifier = 2;
	};
}

if(!isObject(poisonPillsItem))
{
	datablock ItemData(poisonPillsItem)
	{
		category = "Weapon";
		className = "Weapon";
		
		shapeFile = "Add-Ons/gamemode_survival/shapes/pills.4.dts";
		rotate = false;
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		emap = true;
		
		uiName = "Cyanide Pills";
		iconName = "add-ons/gamemode_survival/shapes/icon_pills";
		doColorShift = false;
		
		image = poisonPillsImage;
		canDrop = true;
		itemDesc = "This will poison the first drinkable item in your inventory.";
		invMass = 5;

	};
}

if(!isObject(poisonPillsImage))
{
	datablock ShapeBaseImageData(poisonPillsImage)
	{
		shapeFile = "Add-Ons/gamemode_survival/shapes/pills.4.dts";
		emap = true;
		mountPoint = 0;
		offset = "0 0 0";
		eyeOffset = 0;
		rotation = eulerToMatrix( "0 0 0" );
		
		className = "WeaponImage";
		item = poisonPillsItem;
		
		armReady = true;
		
		doColorShift = poisonPillsItem.doColorShift;
		colorShiftColor = poisonPillsItem.colorShiftColor;
		
		casing = poisonPillsDebris;
		shellExitDir		= "1.0 1.0 1.0";
		shellExitOffset		= "0 0 0";
		shellExitVariance	= 5;	
		shellVelocity		= 10;
		
		stateName[0]					= "Activate";
		stateSound[0]					= weaponSwitchSound;
		stateTimeoutValue[0]			= 0.15;
		stateTransitionOnTimeout[0]		= "Ready";

		stateName[1]					= "Ready";
		stateAllowImageChange[1]		= true;
		stateSequence[1]				= "Ready";
		stateTransitionOnTriggerDown[1]	= "Use";
		
		stateName[2]					= "Use";
		stateScript[2]					= "onUse";
		stateTransitionOnTriggerUp[2]	= "Done";
		
		stateName[3]					= "Done";
		stateTransitionOnAmmo[3]		= "Ready";
		stateTransitionOnNoAmmo[3]		= "UnUse";
		
		stateName[4]					= "UnUse";
		stateEjectShell[4]				= true;
		stateScript[4]					= "onUnUse";
		stateSequence[4]				= "Open";
		stateTimeoutValue[4]			= 0.5;
		stateTransitionOnTimeout[4]		= "Hack";
		stateWaitForTimeout[4]			= true;
		
		stateName[5]					= "Hack";
		stateScript[5]					= "onHack";
	};
}

// ============================================================
// Section 2 : Script
// ============================================================
function poisonPillsImage::onHack(%this, %obj, %slot)
{
	%obj.playThread(1, "root");
	%obj.schedule(32, "unMountImage", %slot);
	
	if(isObject(%client = %obj.client))
	{
		serverCmdUnUseTool(%client);
	}
}

function poisonPillsImage::onUnUse(%this, %obj, %slot)
{
	%tool = %obj.tool[%obj.currTool];
	
	if(isObject(%tool) && %tool.getID() == %this.item.getID())
	{
		%slots = %obj.getDataBlock().maxTools;
		for(%i = 0; %i < %slots; %i++)
		{
			if(%obj.tool[%i].hydration > 0)
			{
				if(isObject(strReplace(%obj.tool[%i].getName(),"Item","PItem")))
				{
					%found = 1;
					%obj.tool[%i] = nameToID(strReplace(%obj.tool[%i].getName(),"Item","PItem"));
					messageClient(%obj.client, 'MsgItemPickup', '', %i, %obj.tool[%i]);
					messageClient(%obj.client, '', "\c3You poisoned the" SPC %obj.tool[%i].uiName @ "!");
					break;
				}
			}
		}
		%obj.playThread(2, "shiftAway");
   		%obj.tool[%obj.currTool] = 0;
		
messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
	}
}

function poisonPillsImage::onUse(%this, %obj, %slot)
{

	%slots = %obj.getDataBlock().maxTools;
	for(%i = 0; %i < %slots; %i++)
	{
		if(%obj.tool[%i].hydration > 0)
		{
			if(isObject(strReplace(%obj.tool[%i].getName(),"Item","PItem")))
			{
				%found = 1;
				//%obj.tool[%i] = strReplace(%obj.tool[%i].getName(),"Item","PItem");
				break;
			}
		}
	}
	if(%found)
	{
		%obj.setImageAmmo(%slot, false);
	}
	else
	{
		%obj.setImageAmmo(%slot, true);
		%client = %obj.client;
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c5You have no poisonable drinks.", 2);
		}
	}
}