datablock itemData( lootMetalPanelItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/bar.dts";
	uiName = "Metal Panel";
	doColorShift = true;
	colorShiftColor = "0.8 0.8 0.9 1";
	itemDesc = "Can be used to repair vehicles or recycled for salvage.";
	invMass = 10;
	recycleValue = 25;
	image = lootMetalPanelImage;
};

datablock ShapeBaseImageData(lootMetalPanelImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/bar.dts";
	item = LootMetalPanelItem;

	doColorShift = LootMetalPanelItem.doColorShift;
	colorShiftColor = LootMetalPanelItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[1] = "Ready";
};

function lootMetalPanelImage::onUse(%this, %obj, %slot)
{
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getEyeVector(), 6));
	%ray = containerRayCast(%start, %end,
		$TypeMasks::VehicleObjectType |
		$TypeMasks::FxBrickObjectType
	);

	%col = getWord(%ray, 0);
	if(isObject(%col) && %col.getType() & $TypeMasks::VehicleObjectType)
	{
		%heal = %col.getDatablock().maxDamage / getRandom(3, 4);
		%col.setDamageLevel(%col.getDamageLevel() - %heal);
		%obj.tool[%obj.currTool] = 0;
		messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
		%obj.unMountImage(0);
	}
}

datablock itemData( lootCanOpenerItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/canOpener.dts";
	iconName = "Add-ons/Gamemode_Survival/shapes/icon_canOpener";
	uiName = "Can Opener";
	doColorShift = true;
	colorShiftColor = "0.8 0.2 0.2 1";
	itemDesc = "With this, you can finally open canned foods.";
	recycleValue = 8;
	invMass = 5;

	image = lootCanOpenerImage;
};

datablock ShapeBaseImageData(lootCanOpenerImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/canOpener.dts";
	item = LootCanOpenerItem;

	doColorShift = LootCanOpenerItem.doColorShift;
	colorShiftColor = LootCanOpenerItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[0] = "Ready";
};

function lootCanOpenerImage::onUse(%this, %obj, %slot)
{
	%slots = %obj.getDataBlock().maxTools;
	for(%i = 0; %i < %slots; %i++)
	{
		if(%obj.tool[%i] == nameToID(lootCannedFoodItem))
		{
			%obj.tool[%i] = nameToID(lootCannedFoodOpenedItem);
			messageClient(%obj.client, 'MsgItemPickup', '', %i, %obj.tool[%i]);
		}
		else if (%obj.tool[%i] == nameToID(lootCannedFoodSmallItem))
		{
			%obj.tool[%i] = nameToID(lootCannedFoodSmallOpenedItem);
			messageClient(%obj.client, 'MsgItemPickup', '', %i, %obj.tool[%i]);
		}
	}
	messageClient(%obj.client, '', '\c3All your locked cans have been unlocked!');
}
datablock ItemData(RadioItem)
{	
	shapeFile = "Add-Ons/Gamemode_Survival/shapes/radio.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Radio";
	iconName = "Add-Ons/Gamemode_Survival/shapes/Icon_Radio";

	image = RadioImage;
	canDrop = true;
	selfExplan = true;
	recycleValue = 8;
	itemDesc = "\c6Hold this while talking to use the radio.";
};

datablock ShapeBaseImageData(RadioImage)
{
	shapeFile = "Add-Ons/Gamemode_Survival/shapes/radio.dts";
	emap = true;

	mountPoint = 0;
	offset = "0 0 0";
	rotation = eulerToMatrix("0 0 15");

	correctMuzzleVector = false;

	className = "WeaponImage";

	item = RadioItem;
	ammo = " ";
	projectile = "";
	projectileType = "";

	melee = true;
	doRetraction = false;
	armReady = false;

	showBricks = false;
};
datablock itemData( lootGearItem : lootPebblesItem )
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/gear.dts";
	iconName = "Add-ons/Gamemode_Survival/Shapes/icon_gear";
	uiName = "Gear";
	doColorShift = true;
	colorShiftColor = "1 1 1 1";
	itemDesc = "Can be used to upgrade fabricators.";
	invMass = 7;
	recycleValue = 10;
	image = lootGearImage;
};

datablock ShapeBaseImageData(lootGearImage)
{
	shapeFile = "Add-Ons/GameMode_Survival/shapes/gear.dts";
	item = LootGearItem;
	rotation = eulerToMatrix("0 -90 0");
	offset = "0 0.4 0";
	doRetraction = false;
	armReady = false;
	doColorShift = LootGearItem.doColorShift;
	colorShiftColor = LootGearItem.colorShiftColor;

	stateName[0] = "Ready";
	stateTransitionOnTriggerDown[0] = "Use";

	stateName[1] = "Use";
	stateScript[1] = "onUse";
	stateTransitionOnTriggerUp[1] = "Ready";
};

function lootGearImage::onUse(%this, %obj, %slot)
{
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getEyeVector(), 6));
	%ray = containerRayCast(%start, %end,
		$TypeMasks::VehicleObjectType |
		$TypeMasks::FxBrickObjectType
	);

	%col = getWord(%ray, 0);
	if(isObject(%col) && %col.getType() & $TypeMasks::FxBrickObjectType)
	{
		if(%col.getDatablock().isFabricator && !%col.gears)
		{
			%col.gears++;
			%obj.tool[%obj.currTool] = 0;
			messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
			%obj.unMountImage(0);
			messageClient(%obj.client, '', '\c3You added a gear to the fabricator!');
		}
	}
}
//########## Armor

//### Items

datablock ItemData(TVestItem)
{
  uiName = "Tactical Vest";
  iconName = "Add-Ons/GameMode_Survival/shapes/kevlar";
  image = TVestImage;
  category = "Tools";
  className = "Weapon";
  shapeFile = "Add-Ons/GameMode_Survival/shapes/kevlar.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0;
  friction = 0.6;
  emap = true;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";
  recycleValue = 5;
  itemDesc = "A set of body armor that increases resistance.";
  canDrop = true;
};

//### Item Image

datablock shapeBaseImageData(TVestImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/kevlar.dts";
  emap = true;
  mountPoint = 0;
  className = "WeaponImage";
  item = TVestItem;
  melee = false;
  doReaction = false;
  armReady = false;
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Ready";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Ready";
  stateTransitionOnTriggerDown[1] = "Fire";
  stateAllowImageChange[1] = true;

  stateName[2] = "Fire";
  stateTransitionOnTriggerUp[2] = "Ready";
  stateTimeoutValue[2] = "0.2";
  stateFire[2] = true;
  stateAllowImageChange[2] = true;
  stateScript[2] = "onFire";
};

datablock ShapeBaseImageData(TVestMountedImage)
{
  shapeFile = "Add-Ons/GameMode_Survival/shapes/kevlar.dts";
  emap = true;
  mountPoint = 2;
  offset = "-0.000 0.04 -0.38";
  rotation = eulerToMatrix("0 0 180");
  eyeOffset = "0.65 1 5.1";
  scale = "1 1 1";
  correctMuzzleVector = true;
  doColorShift = false;
  colorShiftColor = "1 1 1 1";

  stateName[0] = "Activate";
  stateTimeoutValue[0] = 0.1;
  stateTransitionOnTimeout[0] = "Idle";
  stateSound[0] = weaponSwitchSound;

  stateName[1] = "Idle";
  stateAllowImageChange[1] = true;
};

//### Functions

function TVestImage::onFire(%this,%obj,%slot)
{
  %client = %obj.client;
  %player = %obj;
  if(isObject(%player))
  {
    if(%player.getMountedImage(1) $= nametoID(TVestMountedImage) && %player.armor >= 100) return;
    else
    {
		%player.mountImage(TVestMountedImage,1);
		%obj.tool[%obj.currTool] = 0;
		messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
		%obj.unMountImage(0);
		messageClient(%obj.client, '', '\c3You put on the armor (+50)!');
		%obj.armor = mClamp(%obj.armor+50,0,100);
    }
  }
}

function TVestMountedImage::onMount(%this,%obj,%slot) { %obj.hideNode(armor); }
//function TVestMountedImage::onUnMount(%this,%obj,%slot) { messageClient(%obj.client,"","\c3You took off the \c7Tactical Vest\c3 (\c0-15%\c3 Body Protection)!"); }


datablock ExplosionData(rockExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = rockExplosionSound;

   emitter[0] = spearExplosionEmitter;
   emitter[1] = spearExplosionEmitter2;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;


   //radius damage
   radiusDamage        =0;
   damageRadius        = 0;
};

datablock ProjectileData(rockProjectile)
{
   projectileShapeName = "add-ons/gamemode_survival/shapes/ore.dts";
   directDamage        = 40;
   directDamageType  = $DamageType::Direct;
   radiusDamageType  = $DamageType::Direct;
   impactImpulse	   = 100;
   verticalImpulse	   = 100;
   explosion           = rockExplosion;
   particleEmitter     = "";


   muzzleVelocity      = 50;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1;

   hasLight    = false;
};
datablock ShapeBaseImageData(rockImage)
{
   // Basic Item properties
   shapeFile = "add-ons/gamemode_survival/shapes/ore.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item =  lootStoneItem;
   ammo = " ";
   projectile = rockProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.657 0.657 0.657 1";

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	//stateSound[5]				= rockThrowSound;
};

function rockImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function rockImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function rockImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	%obj.tool[%obj.currTool] = 0;
	messageClient(%obj.client, 'MsgItemPickup', '', %obj.currTool, 0);
	%obj.unMountImage(0);
	Parent::onFire(%this, %obj, %slot);
	serverPlay3d(rockThrowSound,%obj.getSlotTransform(%slot));
}


datablock ParticleData(StunRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 0;
   textureName          = "base/data/particles/star1";
   spinSpeed      = 500.0;
   spinRandomMin      = -500.0;
   spinRandomMax      = 500.0;
   colors[0]     = "1 1 0.0 0.9";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 0.2;
   sizes[1]      = 0;

   useInvAlpha = false;
};

datablock ParticleEmitterData(StunEmitter)
{
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.5;
   thetaMin         = 90;
   thetaMax         = 90.1;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "StunRingParticle";

   ejectionPeriodMS = 3;
   phiReferenceVel  = 60480;
   
   uiName = "Emote - Stun";
};

datablock ShapeBaseImageData(StunImage)
{
   shapeFile = "base/data/shapes/empty.dts";
   emap = false;

   mountPoint = $HeadSlot;
   rotation = "1 0 0 -90";
   offset = "0 0 0.5";

   stateName[0]               = "Ready";
   stateTransitionOnTimeout[0]      = "FireA";
   stateTimeoutValue[0]         = 0.01;

   stateName[1]               = "FireA";
   stateTransitionOnTimeout[1]      = "FireA";
   stateWaitForTimeout[1]         = True;
   stateTimeoutValue[1]         = 10000;
   stateEmitter[1]               = StunEmitter;
   stateEmitterTime[1]            = 10000;
};
function rockProjectile::damage(%this,%obj,%col,%fade,%pos,%norm)
{
	echo("lol...");
   %colType = %col.getType();
   Parent::damage(%this,%obj,%col,%fade,%pos,%norm);
   
   if(!(%colType & $TypeMasks::PlayerObjectType))
      return;
   
   %dist = vectorDist(%obj.originPoint,%pos);
   
   if(%obj.noStun || %dist < 10)
      return;
   
   if(%col.isStunned)
   {
      %obj.noStun = 1;
      return;
   }
   
   if(%col.getType() & $TypeMasks::CorpseObjectType)
   {
      //serverPlay3d(batWoodBallStunSound,%pos);
      return;
   }
   
   %col.mountImage(StunImage,2);
   if(%dist > 50) 
      %time = 5000;
   else
      %time = 100*%dist;
   
   //if(isObject(%obj.client) && (!isObject(%obj.client.getControlObject()) || vectorDist(%obj.client.getControlObject().getPosition(),%pos) > 20))
      //%obj.client.play2d(batWoodBallStun2dSound);
   
   //serverPlay3d(batWoodBallStunSound,%pos);
   
   if(isObject(%col.client))
   {
      %transform = %col.getTransform();
      %col.client.camera.setOrbitMode(%col, %transform, 0.5, 8, 8, 1);
      %col.client.camera.mode = "Orbit";
      %col.client.setControlObject(%col.client.camera);
   }
   
   %col.unMountImage(0);
   %col.isStunned = 1;
   %col.schedule(%time,unStun);
   cancel(%col.nextBatTaunt);
   %col.stunTaunting = 0;
}

function Player::unStun(%this)
{
   if(%this.getState() $= "Dead")
      return;
   
   if(%this.getMountedImage(2) == StunImage.getID())
      %this.unMountImage(2);
   
   %this.playThread(2,undo);
   
   %this.schedule(500,unStun2);
}

function Player::unStun2(%this)
{
   %this.isStunned = 0;
   if(isObject(%this.client) && %this.getState() !$= "Dead")
   {
      %this.client.setcontrolobject(%this);
      if(%this.currTool != -1)
         servercmdUseTool(%this.client,%this.currTool);
   }
}