function serverCmdClearItems(%client)
{
	if (!%client.isAdmin)
		return;

	%count = 0;

	for (%i = 0; %i < MainBrickGroup.getCount(); %i++)
	{
		%group = MainBrickGroup.getObject(%i);

		for (%j = 0; %j < %group.getCount(); %j++)
		{
			%brick = %group.getObject(%i);

			if (isObject(%brick.item))
				%count++;

			%brick.setItem(0);
		}
	}

	for (%i = MissionCleanup.getCount() - 1; %i >= 0; %i--)
	{
		%object = MissionCleanup.getObject(%i);

		if (%object.getClassName() $= "Item")
		{
			%object.delete();
			%count++;
		}
	}

	if (%count)
		messageAll('MsgClearBricks', '\c3%1 \c0cleared all items. (%2)', %client.name, %count);
}

function spawnLoot()
{
	cancel($spawnLoot);
	%hats = "HatOutlawItem HatSkimaskItem HatPoliceItem HatHeadsetItem HatHelmetItem";
	%ammo = "advAmmoPistolItem advAmmoMachinePistolItem advAmmoRevolverItem advAmmoRifleItem advAmmoSniperRifleItem advAmmoMachineRifleItem";
	// Trash
	//%items0 = "lootPebblesItem lootTrashCartonItem lootTrashCanItem lootStoneItem lootBranchItem";
	// Common food
	%items1 = " lootStoneItem lootBerriesItem lootCannedFoodItem lootCannedFoodSmallItem lootCannedFoodKeyItem lootCannedFoodKeySmallItem";
	// Drinkable
	%items2 = "lootBeerItem lootSodaItem lootWaterItem lootMetalPanelItem lootJuiceCartonItem lootMilkCartonItem";
	// Useful
	%items3 = "lootRagItem lootBandageItem lootGasCanItem cleanSprayItem RadioItem PrintGun";
	// Weak melee
	%items4 = "lootCanOpenerItem meleeUmbrellaItem meleePanItem meleeKnifeItem meleeCaneItem servicePistolItem";
	// Sidearms
	%items5 = "machinePistolItem automaticPistolItem TVestItem meleeWrenchItem";
	// Misc weapons
	%items6 = "revolverItem gamePistolItem huntingMagnumItem huntingRifleItem lootWaterItem BLUEPRINT"; // "combatRifleItem fieldRifleItem gamePistolItem huntingMagnumItem huntingRifleItem BLUEPRINT";
	// High-power weapons
	%items7 = "fieldRifleItem singleShotgunItem leverRifleItem lootGearItem";
	//%items7 = "sniperRifleItem singleShotgunItem huntingShotgunItem doubleShotgunItem leverRifleItem leverShotgunItem lootGearItem";
	// Light auto weapons
	%items8 = "huntingShotgunItem doubleShotgunItem bearTrapItem poisonPillsItem";
	// Top tier weapons
	%items9 = "shrapGrenItem leverShotgunItem ";

	//huntingShotgunItem leverShotgunItem 
	%quantity = getRandom(7, 30);

	for (%i = 0; %i < %quantity; %i++)
	{
		%quality = getRandom(9);

		%name = "_lootspawn_" @ %quality;
		%count = BrickGroup_888888.NTObjectCount[%name];

		if (!%count)
			continue;
		if(%quality >= 6)
			if(!getRandom(0,1))
				continue;
		%index = getRandom(%count - 1);
		%spawn = BrickGroup_888888.NTObject[%name, %index];

		if (isObject(%spawn.item))
			continue;

		%items = %items[%quality];

		for (%j = 1; %j <= 3; %j++)
			%items = %items SPC %items[%quality - %j];
		if(getRandom(20) == 0) //random chance of spawning a hat too!
			%items = %items SPC %hats;
		else
		if(getRandom(10) == 0) //and some ammo!
			%items = %items SPC %ammo;
		%item = getWord(%items, getRandom(getWordCount(%items) - 1));
		if(%item $= "BLUEPRINT")
		{
			%count = $blueprintcount;
			%r = getRandom(%count-1);
			%item = nameToID("lootBlueprint" @ %r @ "item");
		}
		if (isObject(%item))
		{
			%spawn.item = new Item()
			{
				datablock = %item;
				isLoot = 1;
				static = 1;
				// rotate = 1;
			};
			MissionCleanup.add(%spawn.item);
			%spawn.setItemDirection(getRandom(3)); //mFloor(%spawn.itemDirection)
		}
		else
		{
			// talk("ERROR: Loot" SPC %item SPC "does not exist!");
		}
	}

	
	%className = WheeledVehicle;
	%vehicleMax = 0;

	%vehicle0 = JeepVehicle;

	%count = VehicleSpawnSet.getCount();

	if (getRandom(30) == 0 && %count)
	{
		%index = getRandom(%count - 1);
		%spawn = VehicleSpawnSet.getObject(%index);

		initContainerRadiusSearch(
			%spawn.position, 128,
			$TypeMasks::VehicleObjectType |
			$TypeMasks::PlayerObjectType
		);

		if (!containerSearchNext())
		{
			%dataBlock = %vehicle[getRandom(%vehicleMax)];

			%obj = new (%className)()
			{
				dataBlock = %dataBlock;
				spawnBrick = %spawn;
			};

			MissionCleanup.add(%obj);

			%obj.setTransform(%spawn.getSpawnPoint());
			%obj.setNodeColor("ALL", getRandom() SPC getRandom() SPC getRandom() SPC 1);
		}
	}
	if(getRandom(22) == 0)
	{
		%x = getRandom(-500,500);
		%y = getRandom(-500,500);
		spawnPlane(%x SPC %y SPC "150");
	}
	echo("Spawning loot");
	$spawnLoot = schedule(getRandom(10000, 60000), 0, spawnLoot);
}

function FxDTSBrick::checkLootSpawnLoad(%this)
{
	%name = %this.getName();

	if (getSubStr(%name, 0, 11) $= "_lootspawn_")
		%this.setItem(0);
}

function fxDTSBrick::startLoopSound(%brick)
{
	%brick.playSound(factoryloopSound);
	%brick.soundLoop = %brick.schedule(5000,startLoopSound);
}
function fxDtsBrick::produceItem(%obj,%item)
{
	if(!isObject(%obj))
		return;
	%staticitem = new Item()
	{
		dataBlock = %item;
	};	
	cancel(%obj.soundLoop);
	%obj.playSound(factoryStopSound);
	%staticItem.setTransform(vectorAdd(vectorAdd(%obj.getTransform(),"0 0 1"),vectorScale(vectorCross(%obj.getForwardVector(),%obj.getUpVector()),-1)));
	%obj.busy=0;
}

function BlueprintItemImage::onUse(%this, %obj, %slot)
{
	%start = %obj.getEyePoint();
	%end = vectorAdd(%start, vectorScale(%obj.getEyeVector(), 6));
	%ray = containerRayCast(%start, %end,
		$TypeMasks::VehicleObjectType |
		$TypeMasks::FxBrickObjectType
	);

	%col = getWord(%ray, 0);
	if(isObject(%col) && %col.getType() & $TypeMasks::FxBrickObjectType)
	{
		if(%col.getDatablock().isFactory && !%col.busy)
		{
			echo(%this.item.cost);
			%cost = %this.item.cost;
			%product = %this.item.produce;
			if(%cost <= 0 || !isObject(%product))
				return 0;
			if(%obj.salvage < %cost)
				return 0;
			%obj.salvage-=%cost;
			messageClient(%obj.client, '', '\c3The factory is now producing a %1!',%product.uiname);
			%col.busy=1;
			%col.playSound(factoryStartSound);
			%col.startLoopSound();
			%col.schedule(45000,produceItem,%product);
			return;
		}
		else if(%col.busy)
		{
			messageClient(%obj.client, '', '\c7The factory is already producing something.');
			return;
		}
	}
	messageClient(%obj.client, '', '\c7Use this on a factory to produce an item');
}
function addBlueprint(%item,%cost)
{
	if(!isObject(%item))
		return;
	if($blueprintCount $="")
		$blueprintCount=0;
	if($blueprintMade[%item.getname()])
		return 0;
	%name = "Blueprint - " @ %item.uiName;
	if(isObject(nameToId("lootBlueprint" @ $blueprintCount @ "item")))
		return;
	datablock itemData(BlueprintItem)
	{
		shapeFile = "Add-Ons/GameMode_Survival/shapes/blueprint.dts";
		iconname = "Add-ons/Gamemode_Survival/shapes/icon_blueprint";
		uiName = %name;
		doColorShift = true;
		colorShiftColor = "1 1 1 1";
		itemDesc = "Used to construct an item. Requires " @ %cost @ " salvage";
		invMass = 7;
		cost = %cost;
		produce = %item;
		canDrop=true;
		mass = 1;
		density = 0.2;
		elasticity = 0.2;
		friction = 0.6;
		//image = lootGearImage;
	};
	%b = nameToID(BlueprintItem);
	BlueprintItem.setName("lootBlueprint" @ $blueprintCount @ "item");
	datablock ShapeBaseImageData(BlueprintImage)
	{
		className = "BlueprintItemImage";
		shapeFile = "Add-Ons/GameMode_Survival/shapes/blueprint.dts";
		item = %b;
		rotation = eulerToMatrix("0 0 0");
		offset = "0 0 0";
		doRetraction = false;
		armReady = false;
		doColorShift = true;
		colorShiftColor = "1 1 1 1";
		
		stateName[0] = "Ready";
		stateTransitionOnTriggerDown[0] = "Use";

		stateName[1] = "Use";
		stateScript[1] = "onUse";
		stateTransitionOnTriggerUp[1] = "Ready";
	};
	%im = nameTOID(BlueprintImage);
	BluePrintImage.setName("lootBlueprint" @ $blueprintCount @ "image");
	%b.image = nameToID(%im);
	$blueprintList = trim($blueprintList SPC %b.getName());
	$blueprintMade[%item.getname()] = 1;
	$blueprintCount++;
}
package LootPackage
{
	function BrickVehicleSpawnData::onLoadPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		VehicleSpawnSet.add(%obj);
	}

	function BrickVehicleSpawnData::onPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		VehicleSpawnSet.add(%obj);
	}

	function FxDTSBrickData::onLoadPlant(%this, %obj)
	{
		Parent::onLoadPlant(%this, %obj);
		%obj.schedule(100, checkLootSpawnLoad);
	}

	function Item::respawn(%this)
	{
		if (%this.isLoot)
			%this.delete();
		else
			Parent::respawn(%this);
	}
};

activatePackage("LootPackage");

function spawnPlane(%pos)
{
	
	%dataBlock = HerculesVehicle;
	%className = WheeledVehicle;
	%obj = new (%className)()
	{
		dataBlock = %dataBlock;
	};
	MissionCleanup.add(%obj);
    %vec = vectornormalize(vectorsub(%pos,"0 0 " @ getWord(%pos,2)));   
	%rad = mATan(getWord(%vec,1),getWord(%vec,0));
	%degrees = mRadToDeg(%rad) + 90;
    %obj.setTransform(%pos SPC eulertoaxis("0 0" SPC %degrees));
	%obj.setVelocity(vectorScale(%obj.getForwardVector(),50));
	%obj.setNodeColor("ALL", "0.5 0.5 0.5 1");
	%time = getRandom(4,9)*1000;
	%obj.schedule(%time,spawnCrate,vectorAdd(%obj.getPosition(),"0 0 -7"));
	%obj.schedule(60000,delete);
	%obj.playAudio(0, cargoPlaneSound);
	$Survival::Planes++;
	
	
}
function Vehicle::SpawnCrate(%this)
{
	if(!isObject(%this))
		return;
	spawnCrate(vectorAdd(%this.getPosition(),"0 0 -7"));
}
function spawnCrate(%pos)
{
	%planeItems = "sniperRifleItem riotShotgunItem pairedShotgunItem shrapGrenItem Blueprint";
	for(%i=0;%i<getWordCount(%planeItems);%i++)
	{
		if(!getRandom(0,1))
		{
			%item = getWord(%planeItems,%i);
			if(%item $= "Blueprint")
			{
				%count = $blueprintcount;
				%r = getRandom(%count-1);
				%item = nameToID("lootBlueprint" @ %r @ "item");
			}
			%inv = trim(%inv SPC %item);
		}
	}
	if(%inv $= "")
		return;
	%vehicle = new AIPlayer()
	{
		dataBlock = cratePlayer;
		initialPosition = %pos;
		inventory = %inv;
		crateSize = getWordCount(%inv);
		salvage = getRandom(150,300);
	};
	MissionCleanup.add(%vehicle);
	%vehicle.setTransform(%pos);
	%vehicle.schedule(30000,hidenode,"Para");
	%vehicle.setNodeColor("ALL","0.7 0.7 0.7 1");		

}


if (!isObject(VehicleSpawnSet))
	new SimSet(VehicleSpawnSet);

if (!isEventPending($spawnLoot))
	spawnLoot();
addBlueprint(riotShotgunItem,40);
addBlueprint(pairedShotgunItem,40);
addBlueprint(bearTrapItem,20);
addBlueprint(combatRifleItem,25);
addBlueprint(automaticRifleItem,25);

addBlueprint(assaultRifleItem,30);
addBlueprint(carbineSMGItem,25);
addBlueprint(fieldRifleItem,25);
addBlueprint(submachineGunItem,25);
addBlueprint(sniperRifleItem,50);
addBlueprint(shrapGrenItem,35);
addBlueprint(HatHelmetItem,20);
addBlueprint(TVestItem,20);
addBlueprint(RadioItem,20);
addBlueprint(CanOpenerItem,50);
addBlueprint(AdvAmmoItem,10);
//ammo
//addBlueprint(advAmmoPistolItem,10);
//addBlueprint(advAmmoMachinePistolItem,10);
//"advAmmoPistolItem advAmmoMachinePistolItem advAmmoRevolverItem advAmmoRifleItem advAmmoSniperRifleItem advAmmoMachineRifleItem";
	// Light auto weapons
	//%items9 = "riotShotgunItem pairedShotgunItem shrapGrenItem";
