datablock PlayerData(PlayerSurvivalArmor : PlayerStandardArmor)
{
  uiName = "Survival Player";
  maxTools = 7;
  jumpForce = 1280;
  isSurvivor = 1;

  //firstPersonOnly = 0;
  //thirdPersonOnly = 0;

  canJet = 0;
  mass = 120;

  //minImpactSpeed = 15;
  //speedDamageScale = 5;
  minImpactSpeed = 20;
  speedDamageScale = 0.7;

  jumpEnergyDrain = 32;
  minJumpEnergy = 50;

  cameraTilt = 0;
  cameraMaxDist = 4;
  cameraHorizontalOffset = 0.5;
  cameraVerticalOffset = 1;
  rechargeRate = 0.6;
};

datablock PlayerData(PlayerSurvivalRunningArmor : PlayerSurvivalArmor)
{
  uiName = "";
  maxForwardSpeed = 12; // 10.5

  runForce = 6000;
  jumpForce = 750; // 540

  minRunEnergy = 8; // 2.5
  //minJumpEnergy = 20;

  //runEnergyDrain = 2;
  runEnergyDrain = 1.6; // 2
  //jumpEnergyDrain = 20;
  rechargeRate = 0.3;
};

function PlayerSurvivalArmor::onAdd(%this, %obj)
{
  Parent::onAdd(%this, %obj);

  %obj.setShapeNameDistance(20);
  %obj.setShapeNameColor("1 1 1");

  %obj.satiation = 0.75 + getRandom() * 0.25;
  %obj.hydration = 0.75 + getRandom() * 0.25;
  %obj.salvage = 0;
  %obj.monitorEnergyLevel();
  %obj.tick();
}

function PlayerSurvivalArmor::onTrigger(%this, %obj, %slot, %state)
{
  Parent::onTrigger(%this, %obj, %slot, %state);
  if (%slot == 4 && %state)
  {
    %obj.setDataBlock(PlayerSurvivalRunningArmor);
    %obj.monitorEnergyLevel();
	%start = %obj.getEyePoint();
    %path = vectorScale(%obj.getEyeVector(), 6);
    %end = vectorAdd(%start, %path);

    %mask = (
      $TypeMasks::ItemObjectType |
      $TypeMasks::PlayerObjectType |
      $TypeMasks::VehicleObjectType |
      $TypeMasks::FxBrickObjectType
    );
    %ray = containerRayCast(%start, %end, %mask, %obj);
    if (!%ray)
      return 0;
	if(%ray.getDatablock().crateSize >0 || %ray.crateSize > 0)
	{
		if(!isObject(%image = nameToID(getWord(%ray.inventory,%obj.scrollIndex))))
			return;
		for(%i = 0; %i < %obj.getDatablock().maxTools; %i++)
		{
		  %tool = %obj.tool[%i];
		  if(%tool == 0)
		  {
			 %obj.tool[%i] = %image;
			 %obj.weaponCount++;
			 messageClient(%obj.client,'MsgItemPickup','',%i,%image);
			 %ray.inventory = setWord(%ray.inventory,%obj.scrollIndex,"");
			 %obj.toolMag[%i] = %ray.ammo[%obj.scrollIndex];
			 %obj.client.showCrateInv(%ray);
			 break;
		  }
		}
		if(%ray.getDatablock() == CratePlayer.getid())
		{
				%obj.modSalvage(%ray.salvage);
				%ray.salvage = 0;
				if(trim(%ray.inventory) $= "")
					%ray.delete();
		}
	}
  }
}

function PlayerSurvivalRunningArmor::onTrigger(%this, %obj, %slot, %state)
{
  Parent::onTrigger(%this, %obj, %slot, %state);

  if (%slot == 4 && !%state)
  {
    %obj.setDataBlock(PlayerSurvivalArmor);
    %obj.monitorEnergyLevel();
  }
}

function Player::monitorEnergyLevel(%this, %last)
{
  cancel(%this.monitorEnergyLevel);

  if (%this.getState() $= "Dead" || !isObject(%this.client))
    return;

  %show = %this.getEnergyLevel() < %this.getDataBlock().maxEnergy;

  if (%show != %last)
    commandToClient(%this.client, 'ShowEnergyBar', %show);

  %this.monitorEnergyLevel = %this.schedule(100, monitorEnergyLevel, %show);
}

function Player::addItem(%player,%image)
{
   for(%i = 0; %i < %player.getDatablock().maxTools; %i++)
   {
      %tool = %player.tool[%i];
      if(%tool == 0)
      {
         %player.tool[%i] = %image;
         %player.weaponCount++;
         messageClient(%player.client,'MsgItemPickup','',%i,%image);
         break;
      }
   }
}
function Player::tick(%this)
{
  cancel(%this.tick);
  %mount = %this.getObjectMount();

  if (%this.getState() $= "Dead" || (isObject(%mount) && %mount.isCorpseVehicle))
  {
    if (isObject(%this.client))
    {
      commandToClient(%this.client, 'ClearBottomPrint');
      commandToClient(%this.client, 'ClearCenterPrint');
    }

    return;
  }

  //Satiation
  //%drain = 6.25e-005;
  //%drain = 3.25e-005;
  %drain = 4.25e-005;

  if (%this.satiation <= %drain)
    %this.satiation = 0;
  else
    %this.satiation -= %drain;
  if($Sim::Time - %this.client.lastKillClear > 320)
  {
	  %this.client.lastKillClear = $Sim::Time;
	  $Survival::Kills[%this.client.BL_ID] = mClampF($Survival::Kills[%this.client.BL_ID]-1,0,100);
	  %this.client.applyNig();
  }
  if ($Sim::Time - %this.lastSatiationDamage > 0.25 && %this.satiation < 0.02)
  {
    %factor = 1 - (%this.satiation / 0.02);
    %damage = %factor;

    %this.damage(0, 0, %damage, $DamageType::Suicide);
    %this.lastSatiationDamage = $Sim::Time;
  }

  //Hydration
  %drain = 4.5e-005;

  if (%this.hydration <= %drain)
    %this.hydration = 0;
  else
    %this.hydration -= %drain;

  if ($Sim::Time - %this.lastHydrationDamage > 0.25 && %this.hydration < 0.02)
  {
    %factor = 1 - (%this.hydration / 0.02);
    %damage = %factor;

    %this.damage(0, 0, %damage, $DamageType::Suicide);
    %this.lastHydrationDamage = $Sim::Time;
  }

  //%regen = 0.0025;
  %regen = 0.0035;

  // if (%this.hydration >= 0.5 && %this.satiation >= 0.5 && $Sim::Time - %this.lastDamaged > 30)
  // {
    %this.setDamageLevel(%this.getDamageLevel() - %regen);
  // }
  %text = "<font:palatino linotype:24>";
  if(isObject(%this.client.team))
	  %text = %text @ "\c7Team: " @ %this.client.team.name @ "\n";
  %factor = 1 - %this.getDamagePercent();
  %text = %text @ "\c7Health ";

  if (%factor < 0.2)
    %text = %text @ "\c0";
  else if (%factor < 0.6)
    %text = %text @ "\c3";
  else
    %text = %text @ "\c2";

  %text = %text @ mCeil(%factor * 100) @ "%";
  if(%this.armor > 0)
  {
	%text = %text @ "\c7 Armor:\c6 " @ %this.armor;
  }
  %text = %text @ "\c7 | Salvage \c6";
  %text = %text @ %this.salvage;
  if(%this.lastSalvageMod+2000 > getSimTime())
  {
	  if(%this.salvInc>0)
		%char = "+";
	  %text = %text @ "(" @ %char @ %this.salvInc @")";
  }
   if (%this.getMountedImage(0).item.reload)
	%text = %text @ "\c7 | Ammo \c6" @ %this.ammoStr;
  %sat = %this.satiation;
  if(%sat < 0.2)
	%c = "\c0";
  else if(%sat<0.4)
	%c = "\c3";
  else %c = "\c6";
  %text = %text @ "<just:right>\c7Satiation " @ %c;
  %text = %text @ mFloatLength(%sat * 100, 0) @ "%";
  
  %wat = %this.hydration;
  if(%wat < 0.2)
	%c = "\c0";
  else if(%wat<0.4)
	%c = "\c3";
  else %c = "\c6";
  %text = %text @ "\c7 | Hydration " @ %c;
  %text = %text @ mFloatLength(%wat * 100, 0) @ "% \n";

  if (isObject(%mount))
  {
    %speed = vectorLen(setWord(%mount.getVelocity(), 2, 0));
    %mph = (%speed / 2.64) * 6 * 3600 / 5280;

    %text = %text @ "<just:left>\c7Speed \c6";
    %text = %text @ mFloatLength(%mph, 0) @ " MPH";
    %text = %text @ "<just:right>\c7Fuel \c6";
    %text = %text @ mFloatLength(%mount.fuel, 2) @ "G";
    %text = %text @ "\c7 | Integrity \c6";
    %text = %text @ 100 - mFloatLength(%mount.getDamagePercent() * 100, 0);
    %text = %text @ "% \n";
  }

  %item = %this.tool[%this.currTool];

  if (isObject(%item) && %item.itemDesc !$= "")
  {
    %center = "<font:palatino linotype:32>\c3" @ %item.uiName;

    //if (%item.invMass !$= "")
      //%center = %center @ " [" @ %item.invMass @ "]";

    %center = %center @ "\n\c6" @ %item.itemDesc;
    %center = %center @ "\n\n\n\n";

    if (isObject(%item.image) && !%item.selfExplan)
      %center = %center @ "\c3LMB - Use";
    else if (%item.satiation > 0 || %item.hydration > 0)
    {
      %center = %center @ "\c3E - ";

      if (%item.satiation < %item.hydration)
        %center = %center @ "Drink";
      else
        %center = %center @ "Eat";
    }
    else if(!%item.selfExplan)
      %center = %center @ "\c0Cannot be used";
  }
  else
  {
    %start = %this.getEyePoint();
    %path = vectorScale(%this.getEyeVector(), 6);
    %end = vectorAdd(%start, %path);

    %mask = (
      $TypeMasks::ItemObjectType |
      $TypeMasks::PlayerObjectType |
      $TypeMasks::VehicleObjectType |
      $TypeMasks::FxBrickObjectType
    );

    %exempt = %this;

    if (%this.isMounted())
      %exempt = %this.getObjectMount();

    %ray = containerRayCast(%start, %end, %mask, %exempt);
	
	//%dat = %ray.getDataBlock();
	//if(%dat.image $= "salvImage")
	//	talk("swag");
	//	return;

    if (%ray)
    {
      if (%ray.getType() & $TypeMasks::ItemObjectType)
      {
        %item = %ray.getDataBlock();
		//talk(%item.image);
		//talk(%item);
		if(%item.image !$= "salvImage")
			%center = "<font:palatino linotype:32>\n\n\n\n\n\c3E - Take " @ %item.uiName;
		if(%item.image $= "salvImage")
			%center = "<font:palatino linotype:32>\n\n\n\n\n\c3E - Take " @ %ray.total @ " Salvage";

        //if (%item.invMass !$= "")
          //%center = %center @ " [" @ %item.invMass @ "]";
      }
      else if (%ray.getType() & $TypeMasks::VehicleObjectType)
      {
        %vehicle = %ray.getDataBlock();
        %center = "<font:palatino linotype:32>\n\n\n\n\n\c3E - Enter " @ %vehicle.uiName;
      }
    }
  }

  // %test = %this.clickItemPickup(1);

  // if (%test)
  // {
  //  %item = %test.getDataBlock();
  //  %center = "<font:palatino linotype:32>\n\n\n\n\n";
  //  %center = %center @ "\c3E - Take " @ %item.uiName;

  //  if (%item.invMass !$= "")
  //    %center = %center @ " [" @ %item.invMass @ "]";
  // }

  if (isObject(%this.client) && !%this.client.zombieMedpackting)
  {
	%text = trim(%text);
	%center = trim(%center);
    %this.client.bottomPrint(%text, 0, 1);
	if(%center !$= "")
	{
		%this.client.centerPrint(%center, 0);
	}
	else if(%this.client.lastCenter !$= "")
		%this.client.centerPrint("", 1);
	%this.client.lastCenter = %center;

  }

  %this.tick = %this.schedule(50, tick);
}

function Player::gainSatiation(%this, %amount)
{
  %this.satiation = mClampF(%this.satiation + %amount, 0, 1);
}

function Player::gainHydration(%this, %amount)
{
  %this.hydration = mClampF(%this.hydration + %amount, 0, 1);
}
function GameConnection::showCrateInv(%client,%brick)
{
  %text = "<just:center>\c7Crate Inventory";
  %size = %brick.getDatablock().crateSize;
  if(%size $= "")
	  %size = %brick.crateSize;
  for(%i=0;%i<%size;%i++)
  {
	%item = nameToID(getWord(%brick.inventory,%i));
	%name = %item.UIname;
	if(%i==%client.player.scrollIndex)
		%text = %text @ "\n<div:1>\c7-\c6" @ %name;
	else %text = %text @ "\n\c7-\c7" @ %name;
	  
  }
  centerPrint(%client,%text,2);
}
function GameConnection::showSalvageCrate(%client,%brick)
{
  %text = "<just:center>\c7Crate Salvage -\c3 " @ mFloor(%brick.salvage) @ "\n";
  %text = %text @ "\c6/draw #\c7 - draw salvage from the crate\n";
  %text = %text @ "\c6/store #\c7 - store salvage in the crate";
  centerPrint(%client,%text,2);
}
function serverCmdStore(%client,%amt)
{
	%amt = mFloor(%amt);
	if(%amt <= 0)
		return;
	if(!isObject(%brick = %client.player.crate))
		return;
	if((%client.player.salvage-%amt) < 0)
		return;
	if((%brick.salvage+%amt) > 200)
		%amt = %amt-(%brick.salvage+%amt-200);
	if(vectorDist(%client.player.getPosition(),%brick.getPosition()) > 7)
		return;
	%client.player.modSalvage(%amt*-1);
	%brick.salvage+=%amt;
	%client.showSalvageCrate(%brick);
	
}

function serverCmdDraw(%client,%amt)
{
	%amt = mFloor(%amt);
	if(%amt <= 0)
		return;
	if(!isObject(%brick = %client.player.crate))
		return;
	if((%brick.salvage-%amt) < 0)
		return;
	if(vectorDist(%client.player.getPosition(),%brick.getPosition()) > 7)
		return;
	%brick.salvage-=%amt;
	%client.player.modSalvage(%amt);
	%client.showSalvageCrate(%brick);
	
}
package PlayerPackage
{
	function Observer::onTrigger(%this, %obj, %trigger, %state)
	{
		if(isObject(%client = %obj.getControllingClient()) && %client.zombieMedpackting)
		{
			if(%trigger == 0 && !%state)
			{
				%client.player.zombieMedpackUse = 0;
				%client.zombieMedpackting = false;
				cancel(%client.player.zombieMedpackSched);
				%client.setControlObject(%client.player);
				commandToClient(%client, 'centerPrint', "<color:ffaaaa>Heal Aborted!", 1);
			}
		}
		
		return parent::onTrigger(%this, %obj, %trigger, %state);
	}
  function serverCmdLight(%client)
  {
	if(isObject(%obj = %client.player) && %obj.getDatablock().getID() == ShepherdDogArmor.getID())
	{
		return;
	}
     Parent::serverCmdLight(%client);
    //}
  }

  function Player::playThread(%this, %slot, %sequenceName)
  {
    if (!%this.getDataBlock().isSurvivor || %slot != 3)
    {
      Parent::playThread(%this, %slot, %sequenceName);
      return;
    }

    if (%sequenceName $= "activate")
    {
      %eyePoint = %this.getEyePoint();
      %eyeVector = %this.getEyeVector();

      %ray = containerRayCast(%eyePoint,
        vectorAdd(%eyePoint, vectorScale(%eyeVector, 10)),
        $TypeMasks::All, %this
      );

      if (!%ray || !(%ray.getType() & $TypeMasks::FxBrickObjectType))
        return;
    }

    Parent::playThread(%this, %slot, %sequenceName);

    if (%sequenceName !$= "activate2" || $Sim::Time - %this.lastRapidClick < 0.5)
      return;

    %this.lastRapidClick = $Sim::Time;

    %eyePoint = %this.getEyePoint();
    %eyeVector = %this.getEyeVector();

    %ray = containerRayCast(%eyePoint,
      vectorAdd(%eyePoint, vectorScale(%eyeVector, 5)),
      $TypeMasks::PlayerObjectType |
      $TypeMasks::FxBrickObjectType,
      %this
    );

    if (!%ray)
      return;

    %col = getWord(%ray, 0);

    if (!(%col.getType() & $TypeMasks::PlayerObjectType) || %col.getDatablock() == CratePlayer.getid())
      return;

    %velocity = vectorScale(%this.getForwardVector(), 7.5);
    %velocity = vectorAdd(%velocity, "0 0 5");

    %col.setVelocity(%velocity);
  }

  function GameConnection::spawnPlayer(%this)
  {
	 
    Parent::spawnPlayer(%this);
	if(%this.checkDup() && isObject(%obj = %this.player))
		%obj.changeDatablock(ShepherdDogArmor);
    for(%i = 4; %i < %this.player.getDatablock().maxTools; %i++)
    {
      messageClient(%this, 'MsgItemPickup', '', %i, 0);
    }
  }
//  function Player::damage(%this, %obj, %pos, %amt, %type)
// {
//   parent::damage(%this, %obj, %pos, %amt, %type);
//	if(%this.getDamagePercent() >= 1)
//	{
//		if(%obj != %this && %obj.client.BL_ID != %this.client.BL_ID && %obj.client.BL_ID > 0)
//		{
//			if($Survival::Kills[%this.client.BL_ID] < 11)
//				$Survival::Kills[%obj.client.BL_ID] += 1;
//			else $Survival::Kills[%obj.client.BL_ID] -= 1;
//			%obj.applyNig();
//		}
//	}
//  }
  function Armor::damage(%this, %obj, %src, %pos, %damage, %type)
  {
    if(%obj.getMountedImage(1) == TVestMountedImage.getID() && %obj.armor > 0)
	{
			if(%obj.getMountedImage(2) == HatPoliceMountedImage.getID())
				%damage *= 0.75;
			%obj.armor -= mFloor(%damage);
			if(%obj.armor < 0)
			{
				%leftover = %obj.armor*-1;
				%obj.armor = 0;
				%obj.unMountImage(1);
			}
			else %damage=0;
	}
	else
		if(%obj.getMountedImage(1) == TVestMountedImage.getID())
			%obj.unMountImage(1);
	%damage-=%leftover;
	if(isObject(%src) && isObject(%obj))
		%headshot = matchBodyArea( getHitbox( %src, %obj, %pos ), $headTest );
	if(%headshot && %obj.getMountedImage(2) == HatHelmetMountedImage.getID())
	{
		%damage /= 3;
	}
	
    Parent::damage(%this, %obj, %src, %pos, %damage, %type);

    %obj.lastDamaged = $Sim::Time;
  }
  function GameConnection::checkHat(%client)
  {	
	if(isObject(%obj= %client.player)) // && isObject(%image = %obj.getMountedImage(2)) && %image.isHat
	{
	  %obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
	}
  }
//    function GameConnection::applyNig(%client)
//    {
//	  if(isObject(%obj= %client.player))
//	  {
//		  %black = "0.2 0.0784 0 1";
//		  %white = "1 0.878 0.612 1";
//		  %perc = 0.1;
//		  %maxKills = 15;
//		  %perc = mClampF($Survival::Kills[%client.BL_ID],0,15)/%maxKills;
//		  for(%i=0;%i<3;%i++)
//		  {
//				%y0 = getWord(%white,%i);
//				%y1 = getWord(%black,%i);
//				%val = %y0 + (%perc)*(%y1-%y0)/(1-0);
//				%color = %color SPC %val;
//		  }
//		  %color = %color SPC 1;
//		  %obj.setNodeColor("headskin",%color);
//		  %obj.setNodeColor("lHand",%color);
//		  %obj.setNodeColor("rHand",%color);
//	  }
//	  
//  }
  
//	function GameConnection::applyBodyColors(%this,%overRide)
//	{
//		parent::applyBodyColors(%this,%overRide);
//		if(%this.getClassName() $= "GameConnection" && isObject(%this.player))
//		{
//			%this.player.setFaceName(%this.faceName);
//			%this.applyNig();
//		}
//		%this.overrideUniform = "";


//	}
	function GameConnection::applyBodyParts(%client) {
		%r = Parent::applyBodyParts(%client);
		%client.schedule(200,checkHat);
		if(isObject(%obj = %client.player))
		{
			%obj.hideNode(bicorn); %obj.hideNode(cophat); %obj.hideNode(triplume); %obj.hideNode(flarehelmet); %obj.hideNode(helmet); %obj.hideNode(knithat); %obj.hideNode(plume); %obj.hideNode(pointyhelmet); %obj.hideNode(scouthat); %obj.hideNode(septplume); %obj.hideNode(visor);
		}
		return %r;
	}
  function weaponImage::onMount(%this,%obj,%slot)
	{
		if(%obj.getDatablock().getID() == ShepherdDogArmor.getID())
		{
			//echo(%obj.getMountedImage(%slot).satiation);
			%obj.unMountImage(%slot);
			return;
		}
		Parent::onMount(%this,%obj,%slot);
	}
	function ShepherdDogArmor::onTrigger(%this, %player, %slot, %val)
	{
		if (isObject(%player.client) && %player.getDatablock().getName() $= "ShepherdDogArmor" && %slot == 0 && %val && %player.lastBark + 500 < getSimTime())
		{
			serverPlay3D("ShepherdDogBark" @ getRandom(1, 3) @ "Sound", %player.getPosition());
			%player.lastBark = getSimTime();
			%start = %player.getEyePoint();
			%path = vectorScale(%player.getEyeVector(), 6);
			%end = vectorAdd(%start, %path);
			%mask = (
				$TypeMasks::FxBrickObjectType       |
				$TypeMasks::PlayerObjectType        |
				$TypeMasks::StaticShapeObjectType   |
				$TypeMasks::TerrainObjectType       |
				$TypeMasks::VehicleObjectType
			);
			%ray = containerRayCast(%start, %end, %mask, %player);
		
			if (%ray)
			{
				%col = %ray;
				if (%col.getType() & ($TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType))
				{
					if (miniGameCanDamage(%player, %col) == 1)
					{
						%explosion = new Projectile()
						{
							datablock = SwordProjectile;

							initialPosition = %col.getPosition();
							initialVelocity = 0;
						};

						MissionCleanup.add(%explosion);

						%explosion.setScale(%player.getScale());
						%explosion.explode();
						%col.damage(%player, %col.getPosition(), 25,$DamageType::Default);
					}
				}
			}
		}
		parent::onTrigger(%this, %player, %slot, %val);
	}
};

activatePackage("PlayerPackage");
