datablock ItemData(salvItem)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "add-ons/gamemode_survival/shapes/scrap.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	doColorShift = true;
	colorShiftColor = "0.75 0.75 0.75 1";
	image = salvImage;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(salvImage)
{
	shapeFile = "add-ons/gamemode_survival/shapes/scrap.dts";
	emap = true;
	
	doColorShift = true;
	colorShiftColor = salvItem.colorShiftColor;
	canPickup = false;
};

function serverCmdDs(%client, %x)
{
	serverCmdDropSalvage(%client, %x);
}

function serverCmdDropSalvage(%client, %x)
{
	%m = mFloor(%x);
	%p = %client.player;
	%s = %p.salvage;
	if(%x <= 0)
		return messageClient(%client,"","\c4Please enter a real amount.");
	if(%x > %s)
		return messageClient(%client,"","\c4You do not have enough.");
	%p.modSalvage(-%x);
	
	%salv = new Item()
	{
		datablock = salvItem;
		canPickup = false;
		total = %m;
	};
	%a = getWord(%p.getEyePoint(), 0) + getWord(%p.getEyeVector(), 0) * getWord(%p.getScale(), 0);
	%b = getWord(%p.getEyePoint(), 1) + getWord(%p.getEyeVector(), 1) * getWord(%p.getScale(), 1);
	%c = getWord(%p.getEyePoint(), 2) + getWord(%p.getEyeVector(), 2) * getWord(%p.getScale(), 2);
	//%trans = setWord(%p.getTransform(), 2, getWord(%p.getTransform(), 2) + 4);
	%trans = %a SPC %b SPC %c;
	%salv.setTransform(%trans);
	%salv.setVelocity(VectorScale(%p.getEyeVector(), 10));
	//%salv.setShapeName(%salv.total);
	//MissionCleanup.add(%salv);
}
package SurvivalSalvage
{
	function GameConnection::onDeath(%killed, %killerPlayer, %killer, %a, %b)
	{
		%p = %killed.player;
		%s = %p.salvage;
		%m = mFloor(%s);
		if(%s > 0)
		{
			%salv = new Item()
			{
				datablock = salvItem;
				canPickup = false;
				total = %m;
			};
			%salv.setTransform(setWord(%p.getTransform(), 2, getWord(%p.getTransform(), 2) + 2));
			%salv.setVelocity(VectorScale(%p.getEyeVector(), 15));
			//MissionCleanup.add(%salv);
			//%salv.setShapeName(%salv.total);
			%p.salvage = %p.salvage - %m;
		}
		Parent::onDeath(%killed, %killerPlayer, %killer, %a, %b);
	}
	
	function Armor::onCollision(%this, %obj, %col, %a, %b)
	{
		//talk(%obj.getID());
		if(%obj.isCorpse == 1)
		{
			//talk("no");
			return;
		}
		if(%col.getDatablock().getName() $= "SalvItem")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					%x = %col.total;
					%obj.modSalvage(%x);
					
					%col.canPickup = false;
					%col.delete();
				}
				else
				{
					%col.delete();
					MissionCleanup.remove(%col);
				}
			}
		}
		if(isObject(%col))
			parent::onCollision(%this, %obj, %col, %thing, %other);
	}
};
activatepackage(SurvivalSalvage);