$MPG = 26.4;
$MPG = 10;
$MPG = 7.5;

function HerculesSpeedCheck(%this, %obj)
{
		return;
}
function WheeledVehicle::tick(%this)
{
	cancel(%this.tick);

	%data = %this.getDataBlock();
	if(%data == HerculesVehicle.getid())
		return;
	%speed = vectorLen(setWord(%this.getVelocity(), 2, 0));
	%speedAll = vectorLen(%this.getVelocity());
	%mph = (%speed / 2.64) * 6 * 3600 / 5280;

	%consumed = (%mph / $MPG) * (0.05 / 3600);

	if (%this.fuel - %consumed > 0)
		%this.fuel -= %consumed;
	else
		%this.fuel = 0;

	for (%i = 0; %i < %data.numWheels; %i++)
		%this.setWheelPowered(%i, %this.fuel > 0);

	if (%speedAll >= 10)
	{
		initContainerRadiusSearch(
			%this.getWorldBoxCenter(), 1.5, $TypeMasks::PlayerObjectType
		);

		while (%obj = containerSearchNext())
		{
			%dist = containerSearchCurrRadiusDist();

			if (%dist > 1.5 || %obj.getObjectMount())
				continue;

			%damage = %speedAll;
			%obj.damage(%this, %obj.getHackPosition(), %damage, $DamageType::Vehicle);
		}
	}

	%this.tick = %this.schedule(50, tick);
}

function WheeledVehicle::getWorldBoxSize(%this)
{
	%worldBox = %this.getWorldBox();

	return vectorSub(
		getWords(%worldBox, 3, 5),
		getWords(%worldBox, 0, 2)
	);
}

package VehiclePackage
{
	function WheeledVehicleData::onAdd(%this, %obj)
	{
		Parent::onAdd(%this, %obj);
		if (%obj.isCorpseVehicle)
		{
			return;
		}
		if (getRandom() < 0.1)
			%obj.fuel = 0;
		else
			%obj.fuel = getRandom();

		%obj.tick();
	}

	function WheeledVehicleData::onImpact(%this, %obj, %col, %pos, %vel)
	{
		if (%obj.isCorpseVehicle || %col.isCorpse || %col.getDatablock() == nameToID("CorpseVehicle"))
			return;

		if (%vel < 12)
			return;

		%boxCenter = %obj.getWorldBoxCenter();
		%damage = %vel * vectorDist(%pos, %boxCenter) / (%this.mass / 10);

		%obj.damage(0, %pos, %damage / 32, $DamageType::Vehicle);

		initContainerBoxSearch(%boxCenter,
			vectorScale(%obj.getWorldBoxSize(), 1.1),$TypeMasks::VehicleObjectType);

		while (isObject(%find = containerSearchNext()))
		{
			if (%find == %obj)
				continue;

			if (%find.getDataBlock() != nameToID("DeathVehicle"))
			{
				%find.damage(%obj, %pos, %damage / 16, $DamageType::Vehicle);
				%find.setVelocity(vectorAdd(%find.getVelocity(), %obj.getVelocity()));
			}
		}

		%chance = 0.4 * (vectorLen(%obj.getVelocity()) / %this.maxWheelSpeed);

		%velocity = vectorScale(%obj.getForwardVector(), 30);
		%position = vectorAdd(%obj.getWorldBoxCenter(), vectorScale(%obj.getForwardVector(), 6));
		%position = vectorAdd(%position, "0 0 4");

		for (%i = 0; %i < %this.numMountPoints; %i++)
		{
			if (1 == 1)//(getRandom() >= %chance) //Sry port I had to disable this because it broke a lot of shit.
				continue;

			%player = %obj.getMountedObject(%i);

			if (!isObject(%player))
				continue;

			%player.unmount();
			%player.canDismount = 0;

			%tumble = new WheeledVehicle()
			{
				dataBlock = deathVehicle;
				client = %player.client;
			};

			MissionCleanup.add(%tumble);

			%tumble.mountObject(%player, 0);
			%tumble.setTransform(%position);
			%tumble.setVelocity(%velocity);

			%tumble.schedule(45000, delete);
			%tumble.schedule(3000, tumbleCheck);

			if(isObject(%player.client.camera))
			{
				%player.client.camera.setMode("isCorpseVehicle", %player);
				%player.client.setControlObject(%player.client.camera);
			}
		}
	}

	function WheeledVehicle::mountObject(%this, %obj, %point)
	{
		if(%this.getName() $= "corpseVehicle")
		{
			Parent::mountObject(%this, %obj, %point);
			return;
		}
		if (!isObject(%obj) || %obj.getObjectMount() == %this)
		{
			Parent::mountObject(%this, %obj, %point);
			return;
		}

		if (vectorLen(%this.getVelocity()) < 1)
			Parent::mountObject(%this, %obj, %point);
	}
};

activatePackage("VehiclePackage");
