function player::swol_trapLoop(%pl,%trapPos)
{
	%pscale = getWord(%pl.getScale(),2);
	%tickPeriod = 1;
	cancel(%pl.trapLoop);
	if(!isObject(%trap = %pl.tempTrap))
		return;
	if(isObject(%im = %pl.getMountedImage(0)))
	{
		if((!%im.isTrap || %im.trapDb !$= %trap.placeDb.getName()))
		{
			%pl.swol_trapPlaceStop();
			return;
		}
	}
	else
	{
		%pl.swol_trapPlaceStop();
		return;
	}
	%db = %trap.placeDb;
	%pass = false;
	%trans = %pl.getTransform();
	%posI = posFromTransform(%trans);
	%rotI = rotFromTransform(%trans);
	%eulerRot = (getWord(axisToEuler(%rotI),2)+90)*$PI/180;
	
	%eye = vectorScale(%pl.getEyeVector(),10);
	%ppos = %pl.getEyePoint();
	%mask = ($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType);
	%hr = containerRaycast(%ppos,vectorAdd(%ppos,%eye),%mask,%obj);
	%dist = 4;
	if(vectorDist(getWords(%pl.getPosition(),0,1) SPC 0,getWords(%hr,1,2) SPC 0) < %dist)
		%dist = vectorDist(getWords(%pl.getPosition(),0,1) SPC 0,getWords(%hr,1,2) SPC 0);
	if(%db.groundSafety $= "")
		%groundSafety = 0.5;
	else
		%groundSafety = 0.1;
		
	if(getWord(%pl.getPosition(),2)-getWord(%hr,3) < 0.2)
		if(%dist < %groundSafety)
			%dist = %groundSafety;
	%pos = mCos(%eulerRot)*%dist SPC mSin(%eulerRot)*%dist SPC 0.2;
	%pos = vectorAdd(%pos,%posI);
	%r = containerRayCast(vectorAdd(%pos,"0 0 2"),vectorAdd(%pos,"0 0 -5"),%mask,%trap);
	if(!isObject(getWord(%r,0)))
		%pass = false;
	else
		%pass = true;
	if(%pass)
	{
		
		%hitPos = getWord(%hr,3);
		%topHit = getWord(%r,3);
		%hitPos = mClampF(%hitPos,0,%topHit);
		if(Swol_TrapSet.lockToGrid != 0)
			%pos = swol_lockGridPosition(getWords(%pos,0,1) SPC %hitPos,Swol_TrapSet.lockToGrid+1);
		else
			%pos = getWords(%pos,0,1) SPC %hitPos;
	}
	else
		%topHit = "";
	%px = getWord(%trapPos,0);
	%py = getWord(%trapPos,1);
	%pz = getWord(%trapPos,2);
	%mx = getWord(%pos,0);
	%my = getWord(%pos,1);
	%tx = %mx - %px;
	%ty = %mY - %py;
	%ang = mAtan(%ty,%tx);
	%dist = vectorDist(%mx SPC %my SPC 0,%px SPC %py SPC 0);
	%factor = mClampF(%dist/(20*%tickPeriod),0.15*%tickPeriod,1*%tickPeriod);
	%isToAim = false;
	%distToAim = %dist;
	if(%trapPos $= "")
		%trapPos = %pos;
	else
	{
		if(%dist < 0.01)
		{
			%trapPos = %pos;
			%isToAim = true;
		}
		else
		{
			%trapPos = %px+((%dist*%factor)*mCos(%ang)) SPC %py+((%dist*%factor)*mSin(%ang)) SPC getWord(%pos,2);
		}
	}
	%pos = %trapPos;
	%max = 7;
	if(%pass)
	{
		%scale = %db.checkScale;
		%passMax = %max*%max;
		%passAcceptable = 0.9;
		%passCnt = 0;
		%w = getWord(%scale,0);
		%h = getWord(%scale,1);
		for(%y=0;%y<%max;%y++)
		{
			for(%x=0;%x<%max;%x++)
			{
				%tmp = %pos;
				%tmp = vectorAdd(%tmp,(%x-(%max/2))*(%w*(1/%max)) SPC (%y-(%max/2))*(%h*(1/%max)) SPC 0);
				%r = containerRayCast(vectorAdd(%tmp,"0 0 0.4"),vectorAdd(%tmp,"0 0 -0.2"),($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType),%trap);
				if(isObject(%r))
					%passCnt++;
			}
		}
	}
	if(%passCnt < %passMax*%passAcceptable)
		%pass = false;
	%trap.setTransform(%pos SPC %rotI);
	%r = containerRaycast(%ppos,vectorAdd(%trap.getPosition(),"0 0 0.2"),%mask,%trap);
	if(isObject(%r))
		%pass = false;
	if(%pass)
	{
		initContainerBoxSearch(vectorAdd(%pos,"0 0 0.12"),%db.checkScale,$TypeMasks::FxBrickObjectType | $TypeMasks::staticShapeObjectType);
		while(%obj = containerSearchNext())
		{
			if(%obj == %trap)
				continue;
			if(%obj.isTempTrap)
				continue;
			%pass = false;

			break;
		}
	}
	if(!%pass)
	{
		if(%topHit !$= "")
		{
			%pos = getWords(%pos,0,1) SPC %topHit;
			%tmpPass = true;
		}
		else
		{
			%pos = getWords(%pos,0,1) SPC getWord(%pl.getPosition(),2);
			%tmpPass = false;
		}
	}
	else
		%tmpPass = false;
	if(%tmpPass)
	{
		%scale = %db.checkScale;
		%passMax = %max*%max;
		%passAcceptable = 0.9;
		%passCnt = 0;
		%w = getWord(%scale,0);
		%h = getWord(%scale,1);
		for(%y=0;%y<%max;%y++)
		{
			for(%x=0;%x<%max;%x++)
			{
				%tmp = %pos;
				%tmp = vectorAdd(%tmp,(%x-(%max/2))*(%w*(1/%max)) SPC (%y-(%max/2))*(%h*(1/%max)) SPC 0);
				%r = containerRayCast(vectorAdd(%tmp,"0 0 0.4"),vectorAdd(%tmp,"0 0 -0.2"),($TypeMasks::staticShapeObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::EnvironmentObjectType | $TypeMasks::TerrainObjectType),%trap);
				if(isObject(%r))
					%passCnt++;
			}
		}
		if(%passCnt < %passMax*%passAcceptable)
			%tmpPass = false;
	}
	%trap.setTransform(%pos SPC %rotI);
	if(%tmpPass)
	{
		%r = containerRaycast(%ppos,%trap.getPosition(),%mask,%trap);
		if(isObject(%r))
			%tmpPass = false;
	}
	if(%tmpPass)
	{
		initContainerBoxSearch(vectorAdd(%pos,"0 0 0.12"),%db.checkScale,$TypeMasks::FxBrickObjectType | $TypeMasks::staticShapeObjectType);
		while(%obj = containerSearchNext())
		{
			if(%obj == %trap)
				continue;
			if(%obj.isTempTrap)
				continue;
			%tmpPass = false;
			break;
		}
	}
	if(!%tmpPass)
	{
		if(%topHit $= "")
			%hitPos = getWord(%pl.getPosition(),2);
		%trap.setTransform(getWords(%pos,0,1) SPC %hitPos SPC %rotI);
	}
	else
		%pass = true;
	if(%pass)
	{
		%trap.setNodeColor("ALL","0.4 1 0.4 1");
		%trap.pass = true;
	}
	else
	{
		%trap.setNodeColor("ALL","1 0.4 0.4 1");
		%trap.pass = false;
	}
	//if(isObject(%cl = %pl.client))
	//{
		//bottomPrint(%cl,"<tab:100>\c6Trap\t<color:ffffaa>" @ %db.uiName @ "<just:right>" @ %cntStr @ " <just:left>" @ (!%pass ? "<br><tab:100><color:ffbbbb>Left Click\t<color:ff5555>Invalid Placement" : "<br><tab:100>\c6Left Click\t<color:aaffaa>Place Trap") @ "",1);
	//}
	%pl.trapLoop = %pl.schedule(16*%tickPeriod,swol_trapLoop,%trapPos);
}